#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=prog.ico
#AutoIt3Wrapper_Outfile=Digitaluhr_v4.exe
#AutoIt3Wrapper_Res_Description=Digitaluhr_v4
#AutoIt3Wrapper_Res_Fileversion=4.3.2.0
#AutoIt3Wrapper_Res_LegalCopyright=Gorathan (forum.technik-hobby.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region *** Includes ***
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <Date.au3>
#include <EditConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GuiListView.au3>
#include <GuiMenu.au3>
#include <FileConstants.au3>
#include <InetConstants.au3>
#include <Misc.au3>
#include <MsgBoxConstants.au3>
#include <ProgressConstants.au3>
#include <Sound.au3>
#include <StaticConstants.au3>
#include <Timers.au3>
#include <TrayConstants.au3>
#include <WinAPI.au3>
#include <WinAPIInternals.au3>
#include <WinAPIMisc.au3>
#include <WinAPISys.au3>
#include <WindowsConstants.au3>
#EndRegion *** Includes ***

#Region *** Zusatz-Includes einbinden ***
#include 'Includes\CalcSeason.au3'
#include 'Includes\GuiCtrlCalendar.au3'
#include 'Includes\GuiCtrlSetImageEx.au3'
#include 'Includes\Holidays.au3'
#include 'Includes\Fonts.au3'
#include 'Includes\GetWeekNumber.au3'
#include 'Includes\Ressource.au3'
#EndRegion *** Zusatz-Includes einbinden ***

#Region *** Optionen ***
Opt('MustDeclareVars', 1)
Opt('TrayMenuMode', 3)
Opt('TrayOnEventMode', 1)
Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)
#EndRegion *** Optionen ***

#Region *** Konstanten deklarieren ***
Global Const $sAppTitle = 'Digitaluhr'
Global Const $sAppVersion = '4.3.2.0'
Global Const $sAppIcon = @Compiled ? @AutoItExe : @ScriptDir & '\prog.ico'
Global Const $sAppDate = '26.06.2018'
Global Const $sAppAuthor = 'Gorathan / Oscar'
Global Const $sAppAuthorEMail = 'mailto:admin@technik-hobby.de'
Global Const $sAppURL = 'https://forum.technik-hobby.de'
Global Const $sAppVersionURL = 'https://www.technik-hobby.de/software/digitaluhr_v4.txt'
Global Const $sAppUpdateURL = 'https://www.technik-hobby.de/software/Digitaluhr_v4.exe'
Global Const $sLicence = 'Das Programm steht unter der "CC BY-NC-ND 4.0" Lizenz\n- freie Weitergabe mit Namensnennung\n- nicht kommerziell\n- keine Bearbeitung'
Global Const $sLicenceURL = 'https://creativecommons.org/licenses/by-nc-nd/4.0'
Global Const $sThanks = 'Mein Dank geht an:\n - Meine Frau, für ihre Liebe und Geduld.\n - UEZ (www.autoit.de), für den "File to Base64 String"-Generator.\n - Bugfix (www.autoit.de), für die Feiertagsfunktion.\n - Geonames (www.geonames.org), für die GeoNames-Datenbank.\n - Cedric Knight (fonts@cedders.com) für den Font "Segment7".\n - Severin Meyer (sev.ch@web.de) für den Font "Xolonium".\n - sowie an die Admins und User von www.autoit.de.'
Global Const $sAppDir = @AppDataDir & '\digitaluhr4\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global Const $sInifile = $sAppDir & '\digitaluhr4.ini'
Global Const $sSpecialDaysFile = $sAppDir & '\specialdays.txt'
Global Const $iAppDPI = RegRead('HKEY_CURRENT_USER\Control Panel\Desktop\WindowMetrics', 'AppliedDPI')
Global Const $iIconSize = 24 ; die Groesse der Tray-Icons
#EndRegion *** Konstanten deklarieren ***

#Region *** Systemvoraussetzungen testen ***
If Number(_WinAPI_GetVersion()) < 6.0 Then Exit MsgBox($MB_ICONERROR, StringFormat('%s  -  v%3.3s', $sAppTitle, $sAppVersion), StringFormat('Systemvoraussetzung nicht erfüllt!\nWindows Vista oder höher wird benötigt.'))

If @DesktopHeight < 800 Then Exit MsgBox($MB_ICONERROR, StringFormat('%s  -  v%3.3s', $sAppTitle, $sAppVersion), StringFormat('Systemvoraussetzung nicht erfüllt!\nDie Auflösung des Monitors muß min. 800px in der Höhe betragen.'))

If Not _Singleton($sAppTitle & 'v4', 1) Then Exit MsgBox($MB_ICONERROR, StringFormat('%s  -  v%3.3s', $sAppTitle, $sAppVersion), StringFormat('Die Digitaluhr läuft bereits!\nEs kann nur eine Instanz gestartet werden.'))
#EndRegion *** Systemvoraussetzungen testen ***

OnAutoItExitRegister('_ProgrammExit')

#Region *** Inidatei lesen ***
Global $iTimezone = 1 ; Zeitzone UTC = 0, MEZ = 1 (Sommerzeit wird berechnet)
Global $iLat = 52.3719 ; Breitengrad (Standard = Lehrte, wird aber spaeter anhand der PLZ aus der Geonames-Datenbank geholt)
Global $iLon = 9.9792 ; Laengengrad (Standard = Lehrte, wird aber spaeter anhand der PLZ aus der Geonames-Datenbank geholt)
Global $sPLZ = String(IniRead($sInifile, 'Settings', 'PLZ', '31275')) ; Postleitzahl (Standard = 31275 Lehrte, kann im Einstellungsfenster geaendert werden)
Global $iMainLeft = IniRead($sInifile, 'Settings', 'MainLeft', -1) ; linke Ecke des Fensters (-1 = horizontal zentriert)
Global $iMainTop = IniRead($sInifile, 'Settings', 'MainTop', -1) ; obere Ecke des Fensters (-1 = vertikal zentriert)
Global $sNextHoliday = IniRead($sInifile, 'Settings', 'NextHoliday', '') ; Datum vom naechsten Urlaub (YYYY/MM/DD hh:mm:ss)
Global $bAutostart = IniRead($sInifile, 'Settings', 'StartWithWindows', False) == True ; im Windows-Autostart? ja/nein (true/false)
Global $aGarbage = IniReadSection($sInifile, 'Garbage') ; $aGarbage ist ein Array zum berechnen der Abfallentsorgungstonnen
If @error Then ; wenn nicht vorhanden, wird hier ein Array erstellt
	; Das Vorgabe-Array kann im Einstellungsfenster geaendert werden.
	; Blue = Altpapier, Yellow = Gelber Sack, Black = Restabfall, Orange = O-Tonne
	; die Zahl vor dem Komma = das Datum, wann die jeweilige Tonne abgeholt wurde (0 wenn nicht vorhanden)
	; die Zahl hinter dem Komma = 1-woechentlich, 2-woechentlich, 4-woechentlich (0 wenn nicht vorhanden)
	Global $aGarbage[5][2] = [[4, 0], ['Blue', '2018/06/01,1W'], ['Yellow', '2018/06/01,1W'], ['Black', '2018/06/01,2W'], ['Orange', '2018/05/25,4W']]
EndIf
Global $aAlarmClock[2], $aAlarmOn[2], $aAlarmMP3[2], $adAlarmMP3[2]
$aAlarmClock[0] = IniRead($sInifile, 'Settings', 'Alarmtime1', '00:00:00') ; Alarmzeit von Alarm 1
$aAlarmClock[1] = IniRead($sInifile, 'Settings', 'Alarmtime2', '00:00:00') ; Alarmzeit von Alarm 2
$aAlarmOn[0] = IniRead($sInifile, 'Settings', 'Alarm1On', False) == True ; Alarm 1 aktiv? ja/nein (true/false)
$aAlarmOn[1] = IniRead($sInifile, 'Settings', 'Alarm2On', False) == True ; Alarm 2 aktiv? ja/nein (true/false)
$aAlarmMP3[0] = IniRead($sInifile, 'Settings', 'AlarmMP3_1', '') ; Alarm 1 Sounddatei (Pfad)
$aAlarmMP3[1] = IniRead($sInifile, 'Settings', 'AlarmMP3_2', '') ; Alarm 2 Sounddatei (Pfad)
#EndRegion *** Inidatei lesen ***

_GDIPlus_Startup()

#Region *** Globale Variablen ***
Global $aSpecialDays[1][3], $aSpecialDaysCopy, $aHolidays, $bClockNew = True, $bDayNew = False
_ReadSpecialDays() ; alle Geburtstage, Hochzeitstage und Jahrestage in das Array $aSpecialDays einlesen
Global $aPLZdata = _GetPLZdata() ; die deutschen Postleitzahlen und die dazugehoerigen GPS-Daten (Lat, Lon) laden (Geonames-Datenbank)
Global $iFound = _ArraySearch($aPLZdata, $sPLZ, 0, 0, 0, 0, 1, 1) ; die PLZ in den Daten suchen
If $iFound > -1 Then ; wenn gefunden, dann die GPS-Daten uebernehmen
	$iLat = $aPLZdata[$iFound][9] ; Latitude
	$iLon = $aPLZdata[$iFound][10] ; Longitude
EndIf
For $i = 0 To 1
	If $aAlarmMP3[$i] <> '' Then ; wenn Sounddatei angegeben
		$adAlarmMP3[$i] = _SoundOpen($aAlarmMP3[$i]) ; dann diese oeffnen
	Else
		$adAlarmMP3[$i] = 0 ; ansonsten als nicht vorhanden kennzeichnen
	EndIf
Next
#EndRegion *** Globale Variablen ***

#Region *** Tray-Bitmaps erstellen ***
Global $hInfoBMP = _CreateHBitmapFromImage(_infopng(), $iIconSize)
Global $hSettingsBMP = _CreateHBitmapFromImage(_settingspng(), $iIconSize)
Global $hExitBMP = _CreateHBitmapFromImage(_closepng(), $iIconSize)
Global $hActivateBMP = _CreateHBitmapFromImage(_activate(), $iIconSize)
Global $hCheckBMP = _CreateHBitmapFromImage(_checkpng(), $iIconSize)
Global $hNoCheckBMP = _CreateHBitmapFromImage(_nocheckpng(), $iIconSize)
#EndRegion *** Tray-Bitmaps erstellen ***

#Region *** Traymenue erstellen ***
TraySetIcon($sAppIcon, 0)
Global $idInfo = TrayCreateItem(StringFormat('%s  -  v%3.3s', $sAppTitle, $sAppVersion))
TrayItemSetOnEvent(-1, '_OpenAboutGui')
TrayCreateItem('')
Global $idAutostart = TrayCreateItem('Starte mit Windows')
TrayItemSetOnEvent(-1, '_ChangeAutostart')
If Not @Compiled Then TrayItemSetState(-1, $TRAY_DISABLE) ; der Autostart ist nur im kompilierten Zustand aktiviert
Global $idConfiguration = TrayCreateItem('Konfigurationsfenster öffnen')
TrayItemSetOnEvent(-1, '_OpenConfigGui')
Global $idWinActivate = TrayCreateItem('Fenster nach vorne holen')
TrayItemSetOnEvent(-1, '_WinActivate')
TrayCreateItem('')
Global $idExit = TrayCreateItem('Programm beenden')
TrayItemSetOnEvent(-1, '_CloseMainGui')
TraySetToolTip($sAppTitle)
Global $hMenu = TrayItemGetHandle(0)
_GUICtrlMenu_SetItemBmp($hMenu, 0, $hInfoBMP)
_GUICtrlMenu_SetItemBmp($hMenu, 2, $bAutostart == True ? $hCheckBMP : $hNoCheckBMP)
_GUICtrlMenu_SetItemBmp($hMenu, 3, $hSettingsBMP)
_GUICtrlMenu_SetItemBmp($hMenu, 4, $hActivateBMP)
_GUICtrlMenu_SetItemBmp($hMenu, 6, $hExitBMP)
#EndRegion *** Traymenue erstellen ***

#Region *** Hauptfenster erstellen ***
Global $hMainGui = GUICreate(StringFormat('%s   v%3.3s', $sAppTitle, $sAppVersion), 400, 743, $iMainLeft, $iMainTop, BitOR($WS_POPUPWINDOW, $WS_THICKFRAME), $WS_EX_TOOLWINDOW + $WS_EX_CONTROLPARENT)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseMainGui', $hMainGui)
GUISetBkColor(0xCCFFDD)

Global $aidAlarmOn[2], $aidAlarm[2], $iCheckSize = 28, $bBlockClock = False, $aChangeAlarm[2] = [False, False]
Global $aAlarmTooltip[2] = ['Anklicken zum stellen der Alarmzeit ', 'Anklicken um zur Uhrzeit zurückzukehren']
$aidAlarmOn[0] = GUICtrlCreatePic('', 6, 27, $iCheckSize, $iCheckSize) ; Checkbox von Alarm 1
GUICtrlSetOnEvent(-1, '_SwitchAlarmOnOff')
GUICtrlSetTip(-1, 'Anklicken zum ein-/ausschalten der Alarmzeit 1')
_GuiCtrlSetImageEx(-1, $aAlarmOn[0] ? $adCheck[1] : $adCheck[0])
$aidAlarmOn[1] = GUICtrlCreatePic('', 6, 61, $iCheckSize, $iCheckSize) ; Checkbox von Alarm 2
GUICtrlSetOnEvent(-1, '_SwitchAlarmOnOff')
GUICtrlSetTip(-1, 'Anklicken zum ein-/ausschalten der Alarmzeit 2')
_GuiCtrlSetImageEx(-1, $aAlarmOn[1] ? $adCheck[1] : $adCheck[0])

$aidAlarm[0] = GUICtrlCreatePic('', 40, 25, 32, 32, Default, $GUI_WS_EX_PARENTDRAG) ; Uhr-Symbol von Alarm 1
GUICtrlSetOnEvent(-1, '_ChangeAlarmClock')
GUICtrlSetTip(-1, $aAlarmTooltip[0])
_GuiCtrlSetImageEx(-1, $adClock[0])

$aidAlarm[1] = GUICtrlCreatePic('', 40, 59, 32, 32, Default, $GUI_WS_EX_PARENTDRAG) ; Uhr-Symbol von Alarm 2
GUICtrlSetOnEvent(-1, '_ChangeAlarmClock')
GUICtrlSetTip(-1, $aAlarmTooltip[0])
_GuiCtrlSetImageEx(-1, $adClock[0])

Global $idClockBorder = GUICtrlCreateLabel('', 79, 23, 312, 70, $SS_BLACKFRAME, $GUI_WS_EX_PARENTDRAG) ; Rahmen um die Uhrzeit (versteckt)
GUICtrlSetState(-1, $GUI_HIDE)

Global $aidClock[5] ; Stunden, : , Minuten, : , Sekunden
Global $iClockLeft = 80, $iClockTop = 18, $iClockFont = 56
Global $idHoliday = GUICtrlCreateLabel('', $iClockLeft, 0, 310, 23, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; Feiertag
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Verdana')
$aidClock[0] = GUICtrlCreateLabel('', $iClockLeft, $iClockTop + 10, 90, 60, Default, $GUI_WS_EX_PARENTDRAG) ; Stunden
GUICtrlSetFont(-1, $iClockFont / $iAppDPI * 96, 400, 0, 'Segment7')
$aidClock[1] = GUICtrlCreateLabel(':', $iClockLeft + 90, $iClockTop + 1, 20, 60, Default, $GUI_WS_EX_PARENTDRAG) ; :
GUICtrlSetFont(-1, 42 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$aidClock[2] = GUICtrlCreateLabel('', $iClockLeft + 110, $iClockTop + 10, 90, 60, Default, $GUI_WS_EX_PARENTDRAG) ; Minuten
GUICtrlSetFont(-1, $iClockFont / $iAppDPI * 96, 400, 0, 'Segment7')
$aidClock[3] = GUICtrlCreateLabel(':', $iClockLeft + 200, $iClockTop + 1, 20, 60, Default, $GUI_WS_EX_PARENTDRAG) ; :
GUICtrlSetFont(-1, 42 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$aidClock[4] = GUICtrlCreateLabel('', $iClockLeft + 220, $iClockTop + 10, 90, 60, Default, $GUI_WS_EX_PARENTDRAG) ; Sekunden
GUICtrlSetFont(-1, $iClockFont / $iAppDPI * 96, 400, 0, 'Segment7')
Global $aidUnderline[3], $iUnderlinePos = 0 ; die Unterstriche bei der Uhrzeit erstellen
For $i = 0 To 2
	$aidUnderline[$i] = GUICtrlCreateLabel('', $iClockLeft + $i * 110, $iClockTop + 70, 90, 5)
	GUICtrlSetBkColor(-1, 0x00AA00)
	GUICtrlSetState(-1, $GUI_HIDE)
Next
; zum steuern der Unterstriche dienen <links> und <rechts> fuer die Aenderung der Werte dienen <oben> und <unten>
Global $aidDummy[4], $aAccelKeys[4][2], $aKeys[4] = ['{LEFT}', '{RIGHT}', '{UP}', '{DOWN}']
For $i = 0 To 3
	$aidDummy[$i] = GUICtrlCreateDummy() ; Dummy-Controls, um auf die Tasten reagieren zu koennen
	GUICtrlSetOnEvent(-1, '_ChangeAlarmInput')
	$aAccelKeys[$i][0] = $aKeys[$i]
	$aAccelKeys[$i][1] = $aidDummy[$i]
Next
GUISetAccelerators($aAccelKeys, $hMainGui) ; die Tasten dem Hauptfenster zuweisen

GUICtrlCreateLabel('KW', 20, 100, 50, 30, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; KW
GUICtrlSetFont(-1, 20 / $iAppDPI * 96, 400, 0, 'Xolonium')
Global $idWeekNr = GUICtrlCreateLabel('', 15, 130, 60, 48, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; Wochennummer
GUICtrlSetFont(-1, 32 / $iAppDPI * 96, 400, 0, 'Xolonium')

Global $aidDate[6] ; Tag, . , Monat, . , Jahr, Wochentag (ausgeschrieben)
Global $iDateLeft = 105, $iDateTop = 130, $iDateFont = 32
$aidDate[0] = GUICtrlCreateLabel('', $iDateLeft, $iDateTop, 60, 48, Default, $GUI_WS_EX_PARENTDRAG) ; Tag
GUICtrlSetFont(-1, $iDateFont / $iAppDPI * 96, 400, 0, 'Xolonium')
$aidDate[1] = GUICtrlCreateLabel('.', $iDateLeft + 60, $iDateTop, 15, 48, Default, $GUI_WS_EX_PARENTDRAG) ; .
GUICtrlSetFont(-1, $iDateFont / $iAppDPI * 96, 400, 0, 'Xolonium')
$aidDate[2] = GUICtrlCreateLabel('', $iDateLeft + 75, $iDateTop, 60, 48, Default, $GUI_WS_EX_PARENTDRAG) ; Monat
GUICtrlSetFont(-1, $iDateFont / $iAppDPI * 96, 400, 0, 'Xolonium')
$aidDate[3] = GUICtrlCreateLabel('.', $iDateLeft + 135, $iDateTop, 15, 48, Default, $GUI_WS_EX_PARENTDRAG) ; .
GUICtrlSetFont(-1, $iDateFont / $iAppDPI * 96, 400, 0, 'Xolonium')
$aidDate[4] = GUICtrlCreateLabel('', $iDateLeft + 150, $iDateTop, 120, 48, Default, $GUI_WS_EX_PARENTDRAG) ; Jahr
GUICtrlSetFont(-1, $iDateFont / $iAppDPI * 96, 400, 0, 'Xolonium')
$aidDate[5] = GUICtrlCreateLabel('', $iDateLeft, $iDateTop - 30, 275, 30, Default, $GUI_WS_EX_PARENTDRAG) ; Wochentag (ausgeschrieben)
GUICtrlSetFont(-1, 20 / $iAppDPI * 96, 400, 0, 'Xolonium')

GUICtrlCreateLabel('', 0, $iDateTop + 52, 400, 3, Default, $WS_EX_STATICEDGE) ; horizontaler Trennstrich

Global $aidGarbage[4], $aGarbageTip[4] = ['Altpapier', 'Gelber Sack', 'Restmüll', 'O-Tonne']
For $i = 0 To 3
	$aidGarbage[$i] = GUICtrlCreatePic('', 8 + $i + Mod($i, 2) * 56, 188 + Int($i / 2) * 65, 47, 64, Default, $GUI_WS_EX_PARENTDRAG) ; Abfalltonnen-Grafik
	GUICtrlSetTip(-1, $aGarbageTip[$i], 'Abfallentsorgung nächsten ' & _DayOfWeek(StringLeft($aGarbage[$i + 1][1], 10)), $TIP_INFOICON, $TIP_BALLOON)
	_GuiCtrlSetImageEx(-1, $adGarbage[$i])
Next
GUICtrlCreateLabel('', 125, $iDateTop + 53, 3, 138, Default, $WS_EX_STATICEDGE) ; vertikaler Trennstrich

GUICtrlCreateLabel('Sommerzeit (MESZ)', 130, 190, 260, 25, $SS_CENTER, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Verdana')
Global $idSummertime = GUICtrlCreateLabel('', 130, 215, 260, 28, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; Sommerzeit
GUICtrlSetFont(-1, 20 / $iAppDPI * 96, 600, 0, 'Verdana')

GUICtrlCreateLabel('Sonnenauf-/untergang', 130, 255, 260, 25, $SS_CENTER, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Verdana')
Global $idSun = GUICtrlCreateLabel('', 130, 280, 260, 28, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; Sonnenaufgang / -untergang
GUICtrlSetFont(-1, 20 / $iAppDPI * 96, 600, 0, 'Verdana')
GUICtrlCreateLabel('', 0, 320, 400, 3, Default, $WS_EX_STATICEDGE) ; horizontaler Trennstrich

Global $idNextHolidayText = GUICtrlCreateLabel('Der nächste Urlaub beginnt in:', 10, 325, 340, 20, Default, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 600, 0, 'Tahoma')
Global $idNextHoliday = GUICtrlCreateLabel('', 10, 345, 340, 24, Default, $GUI_WS_EX_PARENTDRAG) ; Countdown zum naechsten Urlaub
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Tahoma')
Global $idDateImage = GUICtrlCreatePic('', 352, 322, 48, 48) ; Datum/Uhrzeit Auswahlbutton
GUICtrlSetOnEvent(-1, '_SelectDate')
GUICtrlSetTip(-1, 'Uhrzeit und Datum für den nächsten Urlaub festlegen')
_GuiCtrlSetImageEx(-1, $dDate)
Global $idDateInput = GUICtrlCreateDate('', 155, 330, 155, 30, $DTS_SHORTDATEFORMAT) ; Datumseingabe (versteckt)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetFont(-1, 16 / $iAppDPI * 96, 600, 0, 'Tahoma')
Global $idTimeInput = GUICtrlCreateDate('00:00', 25, 330, 85, 30, $DTS_TIMEFORMAT) ; Uhrzeiteingabe (versteckt)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetFont(-1, 16 / $iAppDPI * 96, 600, 0, 'Tahoma')
GUICtrlSendMsg($idTimeInput, $DTM_SETFORMATW, 0, 'HH:mm') ; Eingabeformat festlegen

GUICtrlCreateLabel('', 0, 371, 400, 3, Default, $WS_EX_STATICEDGE) ; horizontaler Trennstrich
Global $aidSeason[4], $aSeasonDate[4]
Global $idSeasonPic = GUICtrlCreatePic('', 0, 372, 128, 128, Default, $GUI_WS_EX_PARENTDRAG) ; Jahreszeit-Grafik
GUICtrlCreateLabel('Jahreszeiten (Beginn)', 145, 374, 245, 28, Default, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Verdana')
For $iSeason = 0 To 3
	$aidSeason[$iSeason] = GUICtrlCreateLabel('', 140, 400 + $iSeason * 25, 250, 20, Default, $GUI_WS_EX_PARENTDRAG) ; Jahreszeiten (Beginn)
	GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Courier New')
Next
GUICtrlCreateLabel('', 0, 500, 400, 3, Default, $WS_EX_STATICEDGE) ; horizontaler Trennstrich

Global $aCalendar = _GuiCtrlCalendar_Create(0, 503) ; Kalender erstellen an X-/Y-Position
Global $aidCalendar = _GuiCtrlCalendar_GetDays($aCalendar) ; das Array mit den Ctrl-IDs zu den Tagen holen
Global $idBlank = GUICtrlCreateLabel('', 0, 713, 400, 30, Default, $GUI_WS_EX_PARENTDRAG) ; weisser Hintergrund als Platzhalter fuer zusaetzliche Woche
GUICtrlSetBkColor(-1, 0xFFFFFF)
#EndRegion *** Hauptfenster erstellen ***

#Region *** Konfigurationsfenster erstellen ***
Global $iConfigIndex = -1 ; Variable, zum kennzeichnen welcher Listview-Eintrag bearbeitet wird ("-1" = keiner)
Global $hConfigGui = GUICreate(StringFormat('Konfiguration - %s   v%3.3s', $sAppTitle, $sAppVersion), 510, 765, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), $WS_EX_TOPMOST, $hMainGui)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseConfigGui')
GUISetBkColor(0xC0C0C0, $hConfigGui)
GUISetIcon($sAppIcon)

GUICtrlCreateGroup('Ortsangaben (PLZ, Latitude, Longitude)', 10, 10, 490, 60) ; Gruppe: Ortsangaben
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
GUICtrlCreateLabel('DE -', 25, 36, 40, 25)
GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idConfigPLZ = GUICtrlCreateInput('', 70, 35, 70, 25, $ES_NUMBER) ; PLZ-Eingabe
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
_GUICtrlEdit_SetCueBanner($idConfigPLZ, 'PLZ')
Global $idConfigLat = GUICtrlCreateInput('', 155, 35, 140, 25, BitOR($ES_READONLY, $ES_CENTER)) ; Latitude-Anzeige
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idConfigLon = GUICtrlCreateInput('', 305, 35, 140, 25, BitOR($ES_READONLY, $ES_CENTER)) ; Longitude-Anzeige
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idConfigOSM = GUICtrlCreateButton('', 455, 35, 30, 26) ; OpenStreetMap-Button
GUICtrlSetOnEvent(-1, '_ShowOSM')
GUICtrlSetTip(-1, 'Zeige Koordinaten in OpenStreetMap')
_GuiCtrlSetImageEx(-1, $dMagnifier)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Abfallentsorgung (Altpapier, Gelber Sack, Restmüll, O-Tonne)', 10, 80, 490, 100) ; Gruppe: Abfallentsorgung
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $aidConfigGarbage[4], $aidConfigGarbageDate[4], $aidConfigGarbageFreq[4]
For $i = 0 To 3
	$aidConfigGarbage[$i] = GUICtrlCreatePic('', 25 + Mod($i, 2) * 245, 100 + Int($i / 2) * 40, 24, 32, Default, $GUI_WS_EX_PARENTDRAG) ; Abfalltonnen-Grafik
	_GuiCtrlSetImageEx(-1, $adGarbage[$i])
	$aidConfigGarbageDate[$i] = GUICtrlCreateDate('', 60 + Mod($i, 2) * 245, 105 + Int($i / 2) * 40, 120, 25, $DTS_SHORTDATEFORMAT) ; Datumseingabe
	GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
	GUICtrlSetTip(-1, 'Wann die Tonne geleert wurde (zum berechnen der nächsten Leerung).')
	$aidConfigGarbageFreq[$i] = GUICtrlCreateCombo('', 190 + Mod($i, 2) * 245, 105 + Int($i / 2) * 40, 50, 20, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL)) ; Wochenauswahl
	GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
	GUICtrlSetData(-1, '0W|1W|2W|4W', '0W')
	GUICtrlSetTip(-1, 'In welchem wöchentlichen Abstand die Tonne geleert wird.' & @CRLF & '"0W" für: wird gar nicht geleert.')
Next
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Eingabe/Änderung der besonderen Tage', 10, 190, 490, 425) ; Gruppe: Besondere Tage
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
Global $idInputNew = GUICtrlCreateButton('Neu', 25, 220, 80, 25) ; "Neu"-Button
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_ConfigNewInput')
Global $idInputOk = GUICtrlCreateButton('Eintrag erstellen', 400, 220, 90, 60, $BS_MULTILINE) ; "Eintrag erstellen"-Button
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_ConfigInputOk')
Global $idInputDate = GUICtrlCreateDate('', 115, 220, 120, 25, $DTS_SHORTDATEFORMAT) ; Datumseingabe
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idInputSense = GUICtrlCreateCombo('', 245, 220, 140, 20, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL)) ; Auswahl des besonderen Tages
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
GUICtrlSetData(-1, 'Geburtstag|Hochzeitstag|Jahrestag', 'Geburtstag')
Global $idInputName = GUICtrlCreateInput('', 25, 255, 360, 25) ; Namenseingabe
GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
_GUICtrlEdit_SetCueBanner($idInputName, 'Bitte den Vor-/Nachnamen eingeben...')

Global $idSpecialDays = GUICtrlCreateListView('Datum|Name|Bedeutung', 25, 290, 460, 315, $LVS_SHOWSELALWAYS) ; Liste mit den Daten
GUICtrlSetFont(-1, 10 / $iAppDPI * 96, 400, 0, 'Verdana')
Global $idSpecialDaysContext = GUICtrlCreateContextMenu($idSpecialDays) ; Kontextmenue
Global $idDeleteMark = GUICtrlCreateMenuItem('Alle markierten Einträge löschen', $idSpecialDaysContext)
GUICtrlSetOnEvent(-1, '_DeleteMarkEntrys')
Global $hDelBMP = _GDIPlus_BitmapCreateFromMemory($dDelete, True) ; HBITMAP
_GUICtrlMenu_SetItemBmp(GUICtrlGetHandle($idSpecialDaysContext), $idDeleteMark, $hDelBMP, False)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('MP3-Dateien für die beiden Alarmzeiten', 10, 625, 490, 90) ; Gruppe: Sounddateien (MP3s) fuer die beiden Alarmzeiten
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')

Global $aidConfigAlarmPic[2], $aidConfigAlarmMP3[2], $aidConfigAlarmSelect[2]
For $i = 0 To 1
	$aidConfigAlarmPic[$i] = GUICtrlCreatePic('', 25, 648 + $i * 30, 24, 24) ; Uhr-Symbol
	_GuiCtrlSetImageEx(-1, $adClock[0])
	GUICtrlCreateLabel($i + 1, 55, 648 + $i * 30, 20, 24) ; Alarm Nr.
	GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 400, 0, 'Verdana')
	$aidConfigAlarmMP3[$i] = GUICtrlCreateInput('', 75, 648 + $i * 30, 375, 24, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_READONLY)) ; Pfad zur MP3-Datei
	GUICtrlSetFont(-1, 10 / $iAppDPI * 96, 400, 0, 'Verdana')
	$aidConfigAlarmSelect[$i] = GUICtrlCreateButton('', 455, 647 + $i * 30, 30, 26) ; Auswahlbutton
	GUICtrlSetOnEvent(-1, '_SelectSoundfile')
	_GuiCtrlSetImageEx(-1, $dMagnifier)
Next
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idConfigCancel = GUICtrlCreateButton('', 190, 725, 140, 32) ; "Abbrechen"-Button
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_CloseConfigGui')
_GuiCtrlSetImageEx(-1, $dCancel, 'Abbrechen', $GCSIE_RIGHT, 12, 0, 'Tahoma')
Global $idConfigSave = GUICtrlCreateButton('', 340, 725, 160, 32) ; "Speichern"-Button
GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_CloseConfigGui')
_GuiCtrlSetImageEx(-1, $dOk, 'Speichern', $GCSIE_RIGHT, 12, 0, 'Tahoma')
#EndRegion *** Konfigurationsfenster erstellen ***

#Region *** Alarmfenster erstellen ****
Global $ahAlarmGui[2], $aidAlarmPic[2], $aidAlarmOk[2], $aAlarmStopTimer[2] = [-1, -1]
For $i = 0 To 1 ; beide Alarmfenster erstellen (versteckt)
	$ahAlarmGui[$i] = GUICreate(StringFormat('%s - Alarmzeit %i', $sAppTitle, $i + 1), 450, 190, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), $WS_EX_TOPMOST, $hMainGui)
	GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseAlarmGui', $ahAlarmGui[$i])
	GUISetIcon($sAppIcon)
	$aidAlarmPic[$i] = GUICtrlCreatePic('', 20, 10, 64, 64) ; Wecker-Symbol
	_GuiCtrlSetImageEx(-1, $dAlarmgfx)
	GUICtrlCreateLabel(StringFormat('Die Alarmzeit von Alarm %i wurde erreicht!', $i + 1), 120, 15, 320, 60)
	GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, 0, 'Verdana')
	GUICtrlCreateLabel(StringFormat('Das schließen des Fensters beendet den Alarm.\nNach 10 Minuten wird das Fenster automatisch geschlossen.'), 50, 80, 370, 55)
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
	$aidAlarmOk[$i] = GUICtrlCreateButton('', 120, 145, 210, 34) ; "Schliessen"-Button
	GUICtrlSetOnEvent(-1, '_CloseAlarmGui')
	_GuiCtrlSetImageEx(-1, $dClose, 'Schließen', $GCSIE_RIGHT, 12, 0, 'Verdana')
Next
#EndRegion *** Alarmfenster erstellen ****

#Region *** Programminformationsfenster erstellen ***
Global $hAboutGui, $aidLabel[6], $aidContent[6], $idLicence, $idNewVersion, $idDLcheck, $idDLprogress, $iUpdate = 0
_CreateAboutGui() ; das Programminformationsfenster wird in dieser Funktion erstellt
#EndRegion *** Programminformationsfenster erstellen ***

#Region *** Vorbereitungen und Hauptfenster anzeigen ***
_ClockUpdate(0, 0, 0, 0) ; die Funktion einmal aufrufen, damit beim anzeigen des Fensters die Uhrzeit, Datum usw. schon eingetragen sind
GUISetState(@SW_SHOW, $hMainGui) ; das Hauptfenster anzeigen
GUIRegisterMsg($WM_MOUSEWHEEL, '_WM_MOUSEWHEEL') ; Mousewheel wird zum stellen der Alarmzeiten gebraucht
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY') ; WM_NOTIFY wird fuer den Doppelklick auf das Listview und das aendern beim Date-Control gebraucht
GUIRegisterMsg($WM_COMMAND, '_WM_COMMAND') ; WM_COMMAND wird fuer die Aenderungen bei den Input-Controls (Konfigurationsfenster) gebraucht
_WindowOnDesktop($hMainGui) ; Sicherstellen, dass sich das Hauptfenster auf dem Desktop befindet
_Timer_SetTimer($hMainGui, 100, '_ClockUpdate') ; alle 100ms auf evtl. Aenderungen von Zeit und/oder Datum reagieren
#EndRegion *** Vorbereitungen und Hauptfenster anzeigen ***

WinWaitClose($hMainGui) ; warten, bis das Hauptfenster geschlossen wird
Exit

#Region *** Funktionen ***
Func _CloseMainGui()
	_SaveSettings()
	GUIDelete($hMainGui)
	Exit
EndFunc   ;==>_CloseMainGui

Func _SaveSettings()
	Local $hFile, $sData, $aPos
	$sData = StringFormat('; Diese Datei wird von dem Programm "Digitaluhr v4" verwendet.\r\n; Bitte diese Datei nicht von Hand ändern!\r\n')
	For $i = 0 To UBound($aSpecialDays) - 1 ; alle Eintraege aus dem Array durchgehen
		$sData &= StringFormat('%s|%s|%s\r\n', $aSpecialDays[$i][0], $aSpecialDays[$i][1], $aSpecialDays[$i][2]) ; und als String zusammensetzen
	Next
	$hFile = FileOpen($sSpecialDaysFile, $FO_OVERWRITE) ; Datei zum ueberschreiben oeffnen
	If $hFile <> -1 Then ; wenn erfolgreich, dann...
		FileWrite($hFile, $sData) ; die Daten in die Datei schreiben
		FileClose($hFile) ; und die Datei schliessen
	EndIf
	$aPos = WinGetPos($hMainGui) ; Position des Hauptfensters holen
	IniWrite($sInifile, 'Settings', 'PLZ', $sPLZ)
	IniWrite($sInifile, 'Settings', 'MainLeft', $aPos[0])
	IniWrite($sInifile, 'Settings', 'MainTop', $aPos[1])
	IniWrite($sInifile, 'Settings', 'NextHoliday', $sNextHoliday)
	IniWrite($sInifile, 'Settings', 'StartWithWindows', $bAutostart)
	IniWriteSection($sInifile, 'Garbage', $aGarbage)
	IniWrite($sInifile, 'Settings', 'Alarmtime1', $aAlarmClock[0])
	IniWrite($sInifile, 'Settings', 'Alarmtime2', $aAlarmClock[1])
	IniWrite($sInifile, 'Settings', 'Alarm1On', $aAlarmOn[0])
	IniWrite($sInifile, 'Settings', 'Alarm2On', $aAlarmOn[1])
	IniWrite($sInifile, 'Settings', 'AlarmMP3_1', $aAlarmMP3[0])
	IniWrite($sInifile, 'Settings', 'AlarmMP3_2', $aAlarmMP3[1])
EndFunc   ;==>_SaveSettings

Func _ProgrammExit()
	_SoundClose($adAlarmMP3[0])
	_SoundClose($adAlarmMP3[1])
	_Timer_KillAllTimers($hMainGui)
	_WinAPI_DeleteObject($hDelBMP)
	_WinAPI_DeleteObject($hInfoBMP)
	_WinAPI_DeleteObject($hSettingsBMP)
	_WinAPI_DeleteObject($hActivateBMP)
	_WinAPI_DeleteObject($hExitBMP)
	_WinAPI_DeleteObject($hCheckBMP)
	_WinAPI_DeleteObject($hNoCheckBMP)
	_GDIPlus_Shutdown()
EndFunc   ;==>_ProgrammExit

Func _CloseAlarmGui() ; Das entsprechende Alarmfenster schliessen (beim Schliessen durch den Benutzer)
	Switch @GUI_WinHandle
		Case $ahAlarmGui[0]
			_StopAlarm(0)
		Case $ahAlarmGui[1]
			_StopAlarm(1)
	EndSwitch
EndFunc   ;==>_CloseAlarmGui

Func _StopAlarm($iNr) ; hier wird der Alarmton gestoppt und das Alarmfenster geschlossen (wird auch von _ClockUpdate() aufgerufen)
	If $adAlarmMP3[$iNr] <> '' Then _SoundStop($adAlarmMP3[$iNr])
	TraySetState($TRAY_ICONSTATE_SHOW) ; Tray-Icon wieder anzeigen
	GUISetState(@SW_ENABLE, $hMainGui) ; Hauptfenster wieder aktivieren
	GUISetState(@SW_HIDE, $ahAlarmGui[$iNr]) ; und das Alarmfenster verstecken
EndFunc   ;==>_StopAlarm

Func _ClockUpdate($hWnd, $iMsg, $iIDTimer, $iTime) ; wichtigste Funktion, um auf die Aenderungen beim Datum und der Uhrzeit zu reagieren (Timer-gesteuert)
	Local Const $aSeason[4] = ['Frühlings', 'Sommer', 'Herbst', 'Winter']
	Local Static $iHour, $iMin, $iSec, $iDay, $iMonth, $iYear, $iWDay, $iSeason
	Local $sSummertimeBegin, $sSummertimeEnd
	Local $sUTC, $sLocalTime, $iFound, $sSun, $iNextHoliday, $sNowCalcDate, $iSpecialDay, $iD, $iAge, $aDayTip[31]
	If $iDay <> @MDAY Then ; Aenderungen neuer Tag
		$iDay = @MDAY ; in Static-Variable merken, damit das nur beim Tageswechsel aufgerufen wird
		GUICtrlSetData($aidDate[0], StringFormat('%02i', $iDay))
	EndIf
	If $iMonth <> @MON Then ; Aenderungen neuer Monat
		$iMonth = @MON ; in Static-Variable merken, damit das nur beim Monatswechsel aufgerufen wird
		GUICtrlSetData($aidDate[2], StringFormat('%02i', $iMonth))
		_GuiCtrlCalendar_SetData($aCalendar, @MON, @YEAR)
		GUICtrlSetState($idBlank, (BitAND(GUICtrlGetState($aCalendar[7][6]), $GUI_HIDE) ? $GUI_SHOW : $GUI_HIDE))
		$aidCalendar = _GuiCtrlCalendar_GetDays($aCalendar) ; das Array mit den Ctrl-IDs zu den Tagen holen
	EndIf
	If $iYear <> @YEAR Then ; Aenderungen neues Jahr
		$iYear = @YEAR ; in Static-Variable merken, damit das nur beim Jahreswechsel aufgerufen wird
		GUICtrlSetData($aidDate[4], StringFormat('%04i', $iYear))
		For $iSeason = 0 To 3
			$sUTC = _calcEquiSol($iSeason, @YEAR) ; die Jahreszeit berechnen (UTC)
			$aSeasonDate[$iSeason] = _UTCtoLocalTime($sUTC, False)
			$sLocalTime = _UTCtoLocalTime($sUTC, True)
			GUICtrlSetData($aidSeason[$iSeason], $sLocalTime)
		Next
		$aHolidays = _Feiertage($iYear, 0) ; die Feiertage fuer das neue Jahr einlesen
	EndIf
	If $iWDay <> @WDAY Or $bDayNew Then ; Aenderungen neuer Wochentag
		If $bDayNew Then
			_GuiCtrlCalendar_SetData($aCalendar, @MON, @YEAR) ; Kalender aktualisieren, wenn in der Konfiguration etwas geaendert wurde
			$bDayNew = False
		EndIf
		$iWDay = @WDAY
		GUICtrlSetData($aidDate[5], _DateDayOfWeek($iWDay, $DMW_LOCALE_LONGNAME)) ; Wochentag ausgeschrieben (ML = MultiLanguage) anzeigen
		GUICtrlSetData($idWeekNr, _WeekNumberISO()) ; Wochennummer anzeigen
		$sSun = _GetSunriseAndSunset($iLat, $iLon, $iTimezone, $iYear, $iMonth, $iDay) ; Sonnenaufgang und -untergang holen
		GUICtrlSetData($idSun, $sSun) ; und auf der GUI anzeigen
		$sNowCalcDate = _NowCalcDate(); das aktuelle Datum holen (Format: YYYY/MM/DD)
		GUICtrlSetData($idHoliday, '') ; evtl. vorhandenen Feiertag nicht mehr anzeigen
		$sSummertimeBegin = _MEZ_SummertimeDate(@YEAR, 3) ; Achtung! Format: DD.MM.YYYY
		If StringMid($sSummertimeBegin, 4, 2) = StringMid($sNowCalcDate, 6, 2) Then ; wenn der Beginn der Sommerzeit in diesem Monat liegt, dann...
			$iD = Number(StringMid($sSummertimeBegin, 1, 2)) ; den Tag extrahieren
			_GuiCtrlCalendar_DrawText($aidCalendar[$iD], $iD, 18, 1, 0x2244EE, 0xFFFFFF, 'Beginn der Sommerzeit (plus eine Stunde)') ; und in den Kalender eintragen
		EndIf
		$sSummertimeEnd = _MEZ_SummertimeDate(@YEAR, 10) ; Achtung! Format: DD.MM.YYYY
		If StringMid($sSummertimeEnd, 4, 2) = StringMid($sNowCalcDate, 6, 2) Then ; wenn das Ende der Sommerzeit in diesem Monat liegt, dann...
			$iD = Number(StringMid($sSummertimeEnd, 1, 2)) ; den Tag extrahieren
			_GuiCtrlCalendar_DrawText($aidCalendar[$iD], $iD, 18, 1, 0x2244EE, 0xFFFFFF, 'Ende der Sommerzeit (minus eine Stunde)') ; und in den Kalender eintragen
		EndIf
		GUICtrlSetData($idSummertime, StringFormat('%-6.6s - %-6.6s', $sSummertimeBegin, $sSummertimeEnd)) ; ausserdem in die GUI eintragen
		_CheckGarbage() ; ueberpruefen ob die Abfallentsorgungstonnen angezeigt/versteckt werden muessen
		For $i = 0 To 3
			If StringMid($aSeasonDate[$i], 6, 2) = StringMid($sNowCalcDate, 6, 2) Then ; wenn ein Jahreszeitwechsel in diesem Monat liegt, dann...
				$iD = Number(StringMid($aSeasonDate[$i], 9, 2)) ; den Tag extrahieren
				$aDayTip[$iD] &= StringFormat('%sanfang\r\n', $aSeason[$i]) ; den Jahreszeitanfang als Tooltip vorbereiten
				_GuiCtrlCalendar_DrawText($aidCalendar[$iD], $iD, 18, 1, 0x2244EE, 0xFFFFFF, $aDayTip[$iD]) ; und in den Kalender eintragen
			EndIf
		Next
		; in $aHolidays sind die Feiertage gespeichert (2D-Array: 0 = Datum YYYY/MM/DD, 1 = Feiertagsname, 2 = Geltungsbereich)
		For $i = 0 To UBound($aHolidays) - 1
			If StringMid($aHolidays[$i][0], 6, 2) = @MON Then ; wenn der Feiertag in diesem Monat liegt, dann...
				$iD = Number(StringMid($aHolidays[$i][0], 9, 2)) ; den Tag extrahieren
				$aDayTip[$iD] &= StringFormat('Feiertag: %s\r\n', $aHolidays[$i][0]) ; den Feiertagsnamen als Tooltip vorbereiten
				_GuiCtrlCalendar_DrawText($aidCalendar[$iD], $iD, 18, 1, 0x22EE44, 0xFFFFFF, $aDayTip[$iD]) ; und in den Kalender eintragen
			EndIf
			If $aHolidays[$i][0] = $sNowCalcDate Then ; wenn der neue Tag ein Feiertag ist, dann...
				GUICtrlSetData($idHoliday, $aHolidays[$i][1]) ; den Feiertag anzeigen
				ExitLoop ; es gibt immer nur einen Feiertag pro Tag, also Schleife verlassen
			EndIf
		Next
		; in $aSpecialDays sind alle Geburtstage und sonstigen Jahrestage (Hochzeitstage) gespeichert (2D-Array, aehnlich $aHolidays)
		For $i = 0 To UBound($aSpecialDays) - 1
			If StringMid($aSpecialDays[$i][0], 6, 2) = StringMid($sNowCalcDate, 6, 2) Then ; wenn der Spezialtag in diesem Monat liegt, dann...
				$iD = Number(StringMid($aSpecialDays[$i][0], 9, 2)) ; den Tag extrahieren
				$iAge = _DateDiff('y', $aSpecialDays[$i][0], _DateAdd('M', 1, $sNowCalcDate)) ; das Alter berechnen
				$aDayTip[$iD] &= StringFormat('%s: %s (%s)\r\n', $aSpecialDays[$i][2], $aSpecialDays[$i][1], $iAge) ; den Geburtstag als Tooltip vorbereiten
				_GuiCtrlCalendar_DrawText($aidCalendar[$iD], $iD, 18, 1, 0x2244EE, 0xFFFFFF, $aDayTip[$iD]) ; und in den Kalender eintragen
			EndIf
		Next
	EndIf
	If $iHour <> @HOUR Or $bClockNew Then ; Aenderungen neue Stunde
		$iHour = @HOUR ; in Static-Variable merken, damit das nur beim Stundenwechsel aufgerufen wird
		If Not $bBlockClock Then GUICtrlSetData($aidClock[0], StringFormat('%02i', $iHour)) ; wenn Ausgabe nicht blockiert, dann Stunden anzeigen
	EndIf
	If $iMin <> @MIN Or $bClockNew Then ; Aenderungen neue Minute
		$iMin = @MIN ; in Static-Variable merken, damit das nur beim Minutenwechsel aufgerufen wird
		If Not $bBlockClock Then GUICtrlSetData($aidClock[2], StringFormat('%02i', $iMin)) ; wenn Ausgabe nicht blockiert, dann Minuten anzeigen
		$iNextHoliday = _DateDiff('s', _NowCalc(), $sNextHoliday) ; die Differenz von Heute bis Urlaubsdatum berechnen (in Sekunden)
		GUICtrlSetData($idNextHoliday, _SecondsToTimeString($iNextHoliday)) ; in den Ausgabestring schreiben (formatiert)
	EndIf
	If $iSec <> @SEC Or $bClockNew Then ; Aenderungen neue Sekunde
		$iSec = @SEC ; in Static-Variable merken, damit das nur beim Sekundenwechsel aufgerufen wird
		If Not $bBlockClock Then GUICtrlSetData($aidClock[4], StringFormat('%02i', $iSec)) ; wenn Ausgabe nicht blockiert, dann Sekunden anzeigen
		For $i = 0 To 3
			If _DateDiff('s', $aSeasonDate[$i], _NowCalc()) > 0 Then $iFound = $i ; testen, welche Jahreszeit
		Next
		If $iFound <> $iSeason Then ; wenn eine neue Jahreszeit begonnen hat
			$iSeason = $iFound ; in Static-Variable merken, damit das nur bei neuer Jahreszeit aufgerufen wird
			_GuiCtrlSetImageEx($idSeasonPic, $adSeason[$iSeason]) ; die Jahreszeitgrafik anzeigen
		EndIf
		For $i = 0 To 1 ; die beiden Alarmzeiten abfragen (passiert nur beim Sekundenwechsel)
			If $aAlarmOn[$i] And StringFormat('%02i:%02i:%02i', $iHour, $iMin, $iSec) = $aAlarmClock[$i] Then ; wenn Alarm aktiv und Alarmzeit erreicht
				If $adAlarmMP3[$i] <> '' Then
					_SoundPlay($adAlarmMP3[$i]) ; wenn eine MP3-Datei ausgewaehlt wurde, dann diese abspielen
				Else
					_PlayMP3FromMem($dAlarmSound) ; ansonsten den internen Alarmton abspielen
				EndIf
				$aAlarmStopTimer[$i] = 600 ; 600 Sek. = 10 Min.
				WinMove($ahAlarmGui[$i], '', @DesktopWidth / 2 - 225, @DesktopHeight / 2 - 90) ; Alarmfenster auf den Desktop zentrieren
				GUISetState(@SW_DISABLE, $hMainGui) ; das Hauptfenster deaktivieren
				TraySetState($TRAY_ICONSTATE_HIDE) ; das Tray-Icon verstecken
				GUISetState(@SW_SHOW, $ahAlarmGui[$i]) ; das Alarmfenster anzeigen
			EndIf
			If $aAlarmStopTimer[$i] > 0 Then ; wenn die 10 Min. vom Alarm noch nicht um sind
				_GuiCtrlSetImageEx($aidAlarmOk[$i], $dClose, 'Schließen ' & _S2MS($aAlarmStopTimer[$i]), $GCSIE_RIGHT, 12, 0, 'Verdana') ; mm:ss anzeigen
				$aAlarmStopTimer[$i] -= 1 ; eine Sekunde abziehen
			EndIf
			If $aAlarmStopTimer[$i] = 0 Then ; wenn die 10 Min. vom Alarm um sind
				$aAlarmStopTimer[$i] = -1 ; auf -1 setzen, damit der Alarm nur einmal gestoppt wird
				_StopAlarm($i) ; Alarmfenster automatisch schliessen
			EndIf
		Next
	EndIf
	If $bClockNew Then $bClockNew = False ; falls $bClockNew = TRUE, dann auf FALSE setzen
EndFunc   ;==>_ClockUpdate

Func _S2MS($iSec) ; Sekunden in "mm:ss" umwandeln
	Return StringFormat('(%02i:%02i)', Int($iSec / 60), Mod($iSec, 60))
EndFunc   ;==>_S2MS

Func _SwitchAlarmOnOff() ; Alarm ein-/ausschalten (wird beim Klick auf die Checkbox aufgerufen)
	Local $iIndex = @GUI_CtrlId - $aidAlarmOn[0] ; $iIndex enthaelt 0 oder 1 (je nachdem, welcher Alarm angeklickt wurde)
	$aAlarmOn[$iIndex] = Not $aAlarmOn[$iIndex] ; Status umschalten
	_GuiCtrlSetImageEx($aidAlarmOn[$iIndex], $adCheck[$aAlarmOn[$iIndex]]) ; Haken gesetzt/nicht gesetzt anzeigen
	IniWrite($sInifile, 'Settings', 'Alarm' & $iIndex + 1 & 'On', $aAlarmOn[$iIndex]) ; und in die Inidatei schreiben
EndFunc   ;==>_SwitchAlarmOnOff

Func _ChangeAlarmClock() ; wird beim Klick auf das Uhrsymbol fuer die Alarmzeit aufgerufen
	Local $aTmp[3], $iIndex = @GUI_CtrlId - $aidAlarm[0] ; $iIndex enthaelt 0 oder 1 (je nachdem, welcher Alarm angeklickt wurde)
	If $aChangeAlarm[$iIndex] Then ; wenn Wechsel zurueck zur Uhrzeit
		$bBlockClock = False ; $bBlockClock auf False setzen, damit bei _ClockUpdate() wieder die Uhrzeit angezeigt wird
		$bClockNew = True ; $bClockNew auf TRUE setzen, damit _ClockUpdate() eine Aktualisierung vornimmt (auch wenn noch keine neue Sekunde angebrochen ist)
		GUICtrlSetState($idClockBorder, $GUI_HIDE) ; den Rahmen um die Uhrzeit verstecken
		$aChangeAlarm[$iIndex] = False ; den Status fuer den Alarm wieder auf FALSE setzen
		_GuiCtrlSetImageEx($aidAlarm[$iIndex], $adClock[0]) ; wieder das normale Uhrsymbol (ohne gruenen Rand) anzeigen
		For $i = 0 To 2
			$aTmp[$i] = GUICtrlRead($aidClock[$i * 2]) ; Stunden, Minuten und Sekunden auslesen
			GUICtrlSetState($aidUnderline[$i], $GUI_HIDE) ; den gruenen Unterstrich verstecken
		Next
		$aAlarmClock[$iIndex] = StringFormat('%02i:%02i:%02i', $aTmp[0], $aTmp[1], $aTmp[2]) ; die Alarmzeit in die Variable uebernehmen
		IniWrite($sInifile, 'Settings', 'Alarmtime' & $iIndex + 1, $aAlarmClock[$iIndex]) ; und in der Inidatei speichern
		GUICtrlSetTip($aidAlarm[$iIndex], $aAlarmTooltip[0]) ; den Tooltip "Alarmzeit stellen" anzeigen
		Return
	EndIf
	GUICtrlSetState($idClockBorder, $GUI_SHOW) ; den Rahmen um die Uhrzeit anzeigen
	; fuer den aktiven Alarm
	$aChangeAlarm[$iIndex] = True ; den Status auf TRUE setzen
	_GuiCtrlSetImageEx($aidAlarm[$iIndex], $adClock[1]) ; das Uhrsymbol mit gruenem Rand anzeigen
	GUICtrlSetTip($aidAlarm[$iIndex], $aAlarmTooltip[1]) ; den Tooltip "zurueck zur Uhrzeit" anzeigen
	; fuer den nicht aktiven Alarm (Not $iIndex)
	$aChangeAlarm[Not $iIndex] = False ; den Status auf FALSE setzen
	_GuiCtrlSetImageEx($aidAlarm[Not $iIndex], $adClock[0]) ; das Uhrsymbol ohne Rand anzeigen
	GUICtrlSetTip($aidAlarm[Not $iIndex], $aAlarmTooltip[0]) ; den Tooltip "Alarmzeit stellen" anzeigen
	$bBlockClock = True ; $bBlockClock auf True setzen, damit _ClockUpdate() nicht die Uhrzeit anzeigt
	$aTmp = StringSplit($aAlarmClock[$iIndex], ':', $STR_NOCOUNT) ; Alarmzeit aufsplitten "hh:mm:ss" -> $aTmp[0...2]
	For $i = 0 To 2
		GUICtrlSetData($aidClock[$i * 2], $aTmp[$i]) ; die Alarmzeit bei der Uhrzeit anzeigen
		GUICtrlSetState($aidUnderline[$i], $GUI_HIDE) ; die Unterstriche erstmal verstecken
	Next
	$iUnderlinePos = 0 ; die Position des Unterstrichs auf die Stunden setzen
	GUICtrlSetState($aidUnderline[$iUnderlinePos], $GUI_SHOW) ; und den Unterstrich anzeigen
EndFunc   ;==>_ChangeAlarmClock

Func _ChangeAlarmInput() ; zum stellen der Alarmzeiten mit Hilfe der Cursortasten
	If Not $bBlockClock Then Return ; wenn gar kein Alarm gestellt werden soll, dann Funktion verlassen
	Local $aMax[3] = [23, 59, 59], $iValue
	GUICtrlSetState($aidUnderline[$iUnderlinePos], $GUI_HIDE) ; den zuletzt angezeigten Unterstrich verstecken
	$iValue = GUICtrlRead($aidClock[$iUnderlinePos * 2]) ; den Wert an der Unterstrich-Position auslesen
	Switch @GUI_CtrlId ; je nachdem, welche Taste betaetigt wurde
		Case $aidDummy[0] ; Cursor-Links
			If $iUnderlinePos > 0 Then $iUnderlinePos -= 1 ; wenn Unterstrich noch nicht links, dann Position -= 1
		Case $aidDummy[1] ; Cursor-Rechts
			If $iUnderlinePos < 2 Then $iUnderlinePos += 1 ; wenn Unterstrich noch nicht rechts, dann Position += 1
		Case $aidDummy[2] ; Cursor-Oben
			$iValue += 1 ; den Wert um eins erhoehen
			If $iValue > $aMax[$iUnderlinePos] Then $iValue = 0 ; wenn Maximalwert ueberschritten, dann auf Null setzen
			GUICtrlSetData($aidClock[$iUnderlinePos * 2], StringFormat('%02i', $iValue)) ; den neuen Wert anzeigen
		Case $aidDummy[3] ; Cursor-Unten
			$iValue -= 1 ; den Wert um eins verringern
			If $iValue < 0 Then $iValue = $aMax[$iUnderlinePos] ; wenn Null unterschritten, dann auf Maximalwert setzen
			GUICtrlSetData($aidClock[$iUnderlinePos * 2], StringFormat('%02i', $iValue)) ; den neuen Wert anzeigen
	EndSwitch
	GUICtrlSetState($aidUnderline[$iUnderlinePos], $GUI_SHOW) ; den neuen Unterstrich anzeigen
EndFunc   ;==>_ChangeAlarmInput

Func _WM_MOUSEWHEEL($hWnd, $iMsg, $wParam, $lParam) ; zum stellen der Alarmzeiten mit Hilfe des Mausrades
	#forceref $hWnd, $iMsg, $lParam
	If Not $bBlockClock Then Return $GUI_RUNDEFMSG ; wenn gar kein Alarm gestellt werden soll, dann Funktion verlassen
	Local Const $aMaxVal[3] = [23, 59, 59], $iWheelDelta = 120
	Local $iWheel, $aGuiInfo, $iIndex, $iValue
	$iWheel = _WinAPI_HiWord($wParam) / $iWheelDelta ; HiWord(wParam) / WheelDelta ergibt down = -1, up = 1
	_WinAPI_LockWindowUpdate($hWnd) ; WindowUpdate blockieren (verhindert das flackern beim aendern der Werte)
	GUICtrlSetState($aidUnderline[$iUnderlinePos], $GUI_HIDE) ; den zuletzt angezeigten Unterstrich verstecken
	$aGuiInfo = GUIGetCursorInfo($hMainGui) ; $aGuiInfo[4] enthaelt die Ctrl-ID vom Control unter dem Mauszeiger
	$iIndex = $aGuiInfo[4] - $aidClock[0] ; minus der Ctrl-ID vom ersten Label ergibt 0, 2, 4 fuer die Clock-Label
	Switch $iIndex
		Case 0, 2, 4 ; nur bei den Clock-Label reagieren
			$iValue = GUICtrlRead($aidClock[$iIndex]) + $iWheel ; Wert auslesen und Wheelwert (-1 oder 1) addieren
			If $iValue > $aMaxVal[$iIndex / 2] Then $iValue = 0 ; wenn neuer Wert groesser als Maximalwert, dann Null
			If $iValue < 0 Then $iValue = $aMaxVal[$iIndex / 2] ; wenn neuer Wert kleiner als Null, dann Maximalwert
			GUICtrlSetData($aidClock[$iIndex], StringFormat('%02i', $iValue)) ; neuen Wert setzen
			$iUnderlinePos = $iIndex / 2 ; die Unterstrich-Position auf den neuen Wert (Mauszeiger) setzen
	EndSwitch
	GUICtrlSetState($aidUnderline[$iUnderlinePos], $GUI_SHOW) ; den neuen Unterstrich anzeigen
	_WinAPI_LockWindowUpdate(0) ; WindowUpdate wieder freigeben
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_MOUSEWHEEL

Func _WinActivate() ; holt das Hauptfenster in den Vordergrund
	WinActivate($hMainGui)
EndFunc   ;==>_WinActivate

Func _DayOfWeek($sDate) ; wandelt das Datum (YYYY/MM/DD) in den Wochentag (ausgeschrieben) um
	Local $aDate = StringSplit($sDate, '/', $STR_NOCOUNT) ; Datum aufsplitten
	Local $iDOW = _DateToDayOfWeek($aDate[0], $aDate[1], $aDate[2]) ; Wochentag als Nummer (1...7)
	Return _DateDayOfWeek($iDOW, $DMW_LOCALE_LONGNAME) ; Wochentag als String
EndFunc   ;==>_DayOfWeek

Func _SecondsToTimeString($iSec) ; diese Funktion wandelt die Sekunden in einen String um (Tage, Stunden, Minuten)
	If $iSec <= 0 Then Return '' ; wenn Sekunden gleich Null oder negativ, dann Leerstring zurueckgeben
	Local $iDay, $iHour, $iMin, $sOut = ''
	$iDay = Int($iSec / 86400) ; Tage berechnen
	$iSec = Mod($iSec, 86400) ; Rest nach $iSec
	$iHour = Int($iSec / 3600) ; Stunden berechnen
	$iSec = Mod($iSec, 3600) ; Rest nach $iSec
	$iMin = Int($iSec / 60) ; Minuten berechnen
	$iSec = Mod($iSec, 60) ; Rest nach $iSec
	; je nachdem, ob es Tage, Stunden oder Minuten gibt, werden nur die Vorhandenen in die Ausgabe uebernommen
	If $iDay > 0 Then $sOut &= StringFormat('%i Tag%s%s', $iDay, ($iDay <> 1 ? 'en' : ''), (($iHour > 0 Or $iMin > 0) ? ', ' : ''))
	If $iHour > 0 Then $sOut &= StringFormat('%i Stunde%s%s', $iHour, ($iHour <> 1 ? 'n' : ''), ($iMin > 0 ? ', ' : ''))
	If $iMin > 0 Then $sOut &= StringFormat('%i Minute%s', $iMin, ($iMin <> 1 ? 'n' : ''))
	Return $sOut ; String zurueckgeben
EndFunc   ;==>_SecondsToTimeString

Func _SelectDate() ; Funktion, zum eingeben des Datums und der Uhrzeit des naechsten Urlaubs
	Local Static $bState = False ; die Funktion wird als Umschalter aufgerufen (Eingabe <-> Anzeige)
	Local $sDate, $sTime, $iNextHoliday
	If Not $bState Then ; bei FALSE als Eingabe
		GUICtrlSetData($idDateInput, $sNextHoliday) ; bei der Datumseingabe, den Datumsstring eintragen
		GUICtrlSetData($idTimeInput, $sNextHoliday) ; bei der Uhrzeiteingabe, den Datumsstring eintragen
		GUICtrlSetState($idNextHolidayText, $GUI_HIDE) ; die Textanzeige verstecken
		GUICtrlSetState($idNextHoliday, $GUI_HIDE) ; und den Ausgabestring verstecken
		GUICtrlSetState($idDateInput, $GUI_SHOW) ; die Datumseingabe anzeigen
		GUICtrlSetState($idTimeInput, $GUI_SHOW) ; die Uhrzeiteingabe anzeigen
	Else ; bei TRUE als Anzeige
		GUICtrlSetState($idDateInput, $GUI_HIDE) ; die Datumseingabe verstecken
		GUICtrlSetState($idTimeInput, $GUI_HIDE) ; die Uhrzeiteingabe verstecken
		$sDate = GUICtrlRead($idDateInput) ; das neue Datum auslesen
		$sTime = GUICtrlRead($idTimeInput) ; die neue Uhrzeit auslesen
		$sNextHoliday = StringRegExpReplace($sDate, '(\d{2}).(\d{2}).(\d{4})', '$3/$2/$1 ') & $sTime & ':00' ; in den Datumsstring umwandeln
		$iNextHoliday = _DateDiff('s', _NowCalc(), $sNextHoliday) ; die Differenz von Heute bis neuen Datum berechnen (in Sekunden)
		GUICtrlSetData($idNextHoliday, _SecondsToTimeString($iNextHoliday)) ; in den Ausgabestring schreiben (formatiert)
		GUICtrlSetState($idNextHolidayText, $GUI_SHOW) ; die Textanzeige anzeigen
		GUICtrlSetState($idNextHoliday, $GUI_SHOW) ; den Ausgabestring anzeigen
		IniWrite($sInifile, 'Settings', 'NextHoliday', $sNextHoliday) ; und den Datumsstring in die Inidatei speichern
	EndIf
	$bState = Not $bState ; Status umschalten (Eingabe <-> Anzeige)
EndFunc   ;==>_SelectDate

Func _CheckGarbage() ; diese Funktion berechnet, welche Abfalltonnen angezeigt werden
	Local $aData, $iDiff, $sNowCalcDate = _NowCalcDate()
	For $i = 0 To 3 ; die vier Abfalltonnen durchgehen
		; $aData[0] = Datum (yyyy/mm/dd) des letzten Termins zum berechnen; wenn 0, dann gibt es die Tonne nicht
		; $aData[1] = ob 1-woechentlich, 2-woechentlich, 4-woechentlich; wenn 0, dann gibt es die Tonne nicht
		$aData = StringSplit($aGarbage[$i + 1][1], ',', $STR_NOCOUNT)
		$iDiff = _DateDiff('D', $aData[0], $sNowCalcDate) ; die Differenz von Heute zum letzten Leerungstermin (in Tagen)
		If Mod($iDiff, ($aData[1] * 7)) = 0 Or Mod($iDiff, ($aData[1] * 7)) >= ($aData[1] * 7 - 6) Then ; wenn die Woche mit der Vorgabe uebereinstimmt, dann...
			GUICtrlSetState($aidGarbage[$i], ($aData[1] > 0 ? $GUI_SHOW : $GUI_HIDE)) ; die Tonne anzeigen (wenn Vorgabe > 0)
		Else
			GUICtrlSetState($aidGarbage[$i], $GUI_HIDE) ; ansosten die Tonne verstecken
		EndIf
		GUICtrlSetTip($aidGarbage[$i], $aGarbageTip[$i], 'Abfallentsorgung nächsten ' & _DayOfWeek(StringLeft($aGarbage[$i + 1][1], 10)), $TIP_INFOICON, $TIP_BALLOON)
	Next
EndFunc   ;==>_CheckGarbage

Func _OpenConfigGui()
	Local $hMonitor, $aData, $aMainPos, $aConfigPos, $iLeft, $iTop
	$hMonitor = _WinAPI_MonitorFromWindow($hMainGui) ; feststellen, auf welchem Monitor das Hauptfenster angezeigt wird
	$aData = _WinAPI_GetMonitorInfo($hMonitor) ; die Daten dieses Monitors holen, $aData[0] = $tagRECT-Struktur (Left, Top, Right, Bottom)
	Local $aPos[4] = [DllStructGetData($aData[0], 1), DllStructGetData($aData[0], 2), DllStructGetData($aData[0], 3), DllStructGetData($aData[0], 4)]
	$aMainPos = WinGetPos($hMainGui) ; die Positionsdaten (Left, Top, Width, Height) des Hauptfensters holen
	$aConfigPos = WinGetPos($hConfigGui) ; die Positionsdaten (Left, Top, Width, Height) des Konfigurationsfensters holen
	$iLeft = $aMainPos[0] + ($aMainPos[2] / 2) - ($aConfigPos[2] / 2) ; den linken Rand fuer das Konfigurationsfenster berechnen
	If $iLeft < $aPos[0] + 16 Then $iLeft = $aPos[0] + 16 ; wenn der linke Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	If $iLeft > $aPos[2] - $aConfigPos[2] - 16 Then $iLeft = $aPos[2] - $aConfigPos[2] - 16 ; wenn der rechte Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	$iTop = $aMainPos[1] + ($aMainPos[3] / 2) - ($aConfigPos[3] / 2) ; den oberen Rand fuer das Konfigurationsfenster berechnen
	If $iTop < $aPos[1] + 16 Then $iTop = $aPos[1] + 16 ; wenn der obere Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	If $iTop > $aPos[3] - $aConfigPos[3] - 16 Then $iTop = $aPos[3] - $aConfigPos[3] - 16 ; wenn der untere Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	WinMove($hConfigGui, '', $iLeft, $iTop) ; das Konfigurationsfenster an diese Position (Left, Top) verschieben
	$aSpecialDaysCopy = $aSpecialDays ; eine Kopie der besonderen Tage anlegen (es wird mit der Kopie gearbeitet und erst beim "Speichern" ins Original uebernommen)
	GUICtrlSetData($idConfigPLZ, $sPLZ) ; die PLZ in das Eingabefeld eintragen
	For $i = 0 To 3 ; die Daten fuer die 4 Abfalltonnen eintragen
		GUICtrlSetData($aidConfigGarbageDate[$i], StringLeft($aGarbage[$i + 1][1], 10))
		GUICtrlSetData($aidConfigGarbageFreq[$i], StringRight($aGarbage[$i + 1][1], 2))
	Next
	GUICtrlSetData($aidConfigAlarmMP3[0], $aAlarmMP3[0]) ; MP3-Datei fuer Alarm 1
	GUICtrlSetData($aidConfigAlarmMP3[1], $aAlarmMP3[1]) ; MP3-Datei fuer Alarm 2
	$iConfigIndex = -1 ; Variable, zum kennzeichnen welcher Listview-Eintrag bearbeitet wird ("-1" = keiner)
	_ConfigListSort() ; das Listview sortieren
	GUICtrlSetData($idInputSense, 'Geburtstag') ; Vorauswahl fuer die Combobox
	GUISetState(@SW_DISABLE, $hMainGui) ; das Hauptfenster deaktivieren
	GUISetState(@SW_SHOW, $hConfigGui) ; und das Konfigurationsfenster anzeigen
EndFunc   ;==>_OpenConfigGui

Func _CloseConfigGui()
	If @GUI_CtrlId = $idConfigSave Then ; wenn auf "Speichern" geklickt wurde
		$sPLZ = GUICtrlRead($idConfigPLZ) ; die PLZ auslesen
		$aSpecialDays = $aSpecialDaysCopy ; die Kopie fuer besonderen Tage in das Original uebernehmen
		For $i = 0 To 3 ; die Daten fuer die 4 Abfalltonnen auslesen
			$aGarbage[$i + 1][1] = StringRegExpReplace(GUICtrlRead($aidConfigGarbageDate[$i]), '(\d{2}).(\d{2}).(\d{4})', '$3/$2/$1,') & GUICtrlRead($aidConfigGarbageFreq[$i])
		Next
		For $i = 0 To 1 ; die MP3-Dateien fuer die beiden Alarmzeiten auslesen
			If $aAlarmMP3[$i] <> '' Then _SoundClose($adAlarmMP3[$i]) ; die bisherige Sounddatei schliessen
			$aAlarmMP3[$i] = GUICtrlRead($aidConfigAlarmMP3[$i]) ; den Pfad fuer die neue MP3-Datei einlesen
			If $aAlarmMP3[$i] <> '' Then ; wenn ein Pfad vorhanden ist, dann...
				$adAlarmMP3[$i] = _SoundOpen($aAlarmMP3[$i]) ; die Sounddatei oeffnen
			Else ; ansonsten...
				$adAlarmMP3[$i] = 0 ; als nicht vorhanden kennzeichnen
			EndIf
		Next
		_SaveSettings() ; die neue Konfiguration speichern
		$bDayNew = True ; $bDayNew auf TRUE setzen, damit die neuen Daten im Kalender eingetragen werden
	EndIf
	GUISetState(@SW_ENABLE, $hMainGui) ; das Hauptfenster wieder aktivieren
	GUISetState(@SW_HIDE, $hConfigGui) ; und das Konfigurationsfenster verstecken
EndFunc   ;==>_CloseConfigGui

Func _DeleteMarkEntrys() ; Auswahl ueber Kontextmenue vom Listview (Konfigurationsfenster)
	Local $aSelIndices = _GetSelectedIndizes($hConfigGui, $idSpecialDays) ; ermitteln, welche Eintraege im Listview markiert sind
	If @error Then Return ; wenn kein Eintrag, dann Funktion verlassen
	For $i = UBound($aSelIndices) - 1 To 0 Step -1 ; das Array rueckwarts durchgehen, weil sonst die Indizes nicht mehr stimmen
		_ArrayDelete($aSpecialDaysCopy, $aSelIndices[$i]) ; den markierten Eintrag aus dem Array mit den "besonderen Tagen" loeschen (aus der Kopie!)
	Next
	_GUICtrlListView_DeleteItemsSelected($idSpecialDays) ; die Eintraege aus dem Listview entfernen
EndFunc   ;==>_DeleteMarkEntrys

Func _GetSelectedIndizes($hGui, $idListview, $iFlag = 1) ; eine optimierte Version (kein ReDim) von "_GUICtrlListView_GetSelectedIndices"
	Local $sSeparatorChar = Opt('GUIDataSeparatorChar') ; Trennzeichen auslesen
	Local $sSelected = ControlListView($hGui, '', $idListview, 'GetSelected', $iFlag) ; Selektierte Einträge auslesen
	If $sSelected = '' Then Return SetError(1, 0, '') ; wenn kein Eintrag selektiert war, dann Funktion mit Fehlermeldung verlassen
	Return SetError(0, 0, StringSplit($sSelected, $sSeparatorChar, 2)) ; Selektiere Einträge in ein Array aufsplitten
EndFunc   ;==>_GetSelectedIndizes

Func _SelectSoundfile() ; zur Auswahl der MP3-Dateien (Konfigurationsfenster)
	Local Static $sInitDir
	Local $sFile = FileOpenDialog('Alarmsound-Auswahl', $sInitDir, 'MP3-Dateien (*.mp3)', $FD_FILEMUSTEXIST, '', $hConfigGui)
	If @error Then ; wenn der Benutzer aus "Abbrechen" geklickt hat
		Switch @GUI_CtrlId ; dann das entsprechende Feld leeren
			Case $aidConfigAlarmSelect[0]
				GUICtrlSetData($aidConfigAlarmMP3[0], '')
			Case $aidConfigAlarmSelect[1]
				GUICtrlSetData($aidConfigAlarmMP3[1], '')
		EndSwitch
		Return ; bei "Abbrechen" die Funktion hier verlassen
	EndIf
	$sInitDir = @WorkingDir ; das neue @WorkingDir merken (Static-Variable)
	Switch @GUI_CtrlId ; und den Pfad zu der MP3-Datei ins entsprechende Feld eintragen
		Case $aidConfigAlarmSelect[0]
			GUICtrlSetData($aidConfigAlarmMP3[0], $sFile)
		Case $aidConfigAlarmSelect[1]
			GUICtrlSetData($aidConfigAlarmMP3[1], $sFile)
	EndSwitch
EndFunc   ;==>_SelectSoundfile

Func _ShowOSM() ; Funktion, zum Aufruf von OpenStreetMap mit den Koordinaten des Ortes (Konfigurationsfenster)
	Local $sLat, $sLon
	$sLat = GUICtrlRead($idConfigLat)
	$sLon = GUICtrlRead($idConfigLon)
	ShellExecute(StringFormat('https://www.openstreetmap.org/search?query=%s,%s', $sLat, $sLon))
EndFunc   ;==>_ShowOSM

Func _ConfigNewInput() ; Aufruf vom "Neu"-Button (Konfigurationsfenster)
	$iConfigIndex = -1 ; markieren, dass es ein neuer Eintrag werden soll (keine Bearbeitung eines Vorhandenen)
	GUICtrlSetData($idInputDate, '') ; Datumseingabe auf heutiges Datum setzen
	GUICtrlSetData($idInputName, '') ; Namenseingabe leeren
	GUICtrlSetData($idInputSense, 'Geburtstag') ; Vorauswahl fuer die Combobox
	GUICtrlSetData($idInputOk, 'Eintrag erstellen') ; den "Ok"-Button entsprechend kennzeichnen
	GUICtrlSetState($idInputOk, $GUI_SHOW) ; und anzeigen
	GUICtrlSetState($idInputName, $GUI_FOCUS) ; den Eingabefocus auf das Namensfeld setzen
EndFunc   ;==>_ConfigNewInput

Func _ConfigInputOk() ; Aufruf vom "Ok"-Button (Konfigurationsfenster)
	Local $sDate, $sName, $sSense, $iCount
	$sDate = StringRegExpReplace(GUICtrlRead($idInputDate), '(\d{2}).(\d{2}).(\d{4})', '$3/$2/$1') ; das Datum auslesen und umwandeln "TT.MM.YYYY" -> "YYYY/MM/TT"
	$sName = GUICtrlRead($idInputName) ; den Namen auslesen
	$sSense = GUICtrlRead($idInputSense) ; die Combobox (Geburtstag/Hochzeitstag/Jahrestag) auslesen
	If $iConfigIndex = -1 Then ; wenn ein neuer Eintrag erstellt werden soll
		$iCount = UBound($aSpecialDaysCopy) ; die Anzahl fuer das Array der besonderen Tage holen
		ReDim $aSpecialDaysCopy[$iCount + 1][3] ; das Array um eins erhoehen
		$aSpecialDaysCopy[$iCount][0] = $sDate ; die Eingabedaten ins Array uebernehmen
		$aSpecialDaysCopy[$iCount][1] = $sName
		$aSpecialDaysCopy[$iCount][2] = $sSense
		GUICtrlCreateListViewItem(StringFormat('%s|%s|%s', $sDate, $sName, $sSense), $idSpecialDays) ; und einen Eintrag im Listview erstellen
	Else ; ansonsten (Aenderung eines bestehenden Eintrags)
		$aSpecialDaysCopy[$iConfigIndex][0] = $sDate ; die Eingabedaten ins Array uebernehmen
		$aSpecialDaysCopy[$iConfigIndex][1] = $sName
		$aSpecialDaysCopy[$iConfigIndex][2] = $sSense
		_GUICtrlListView_SetItemText($idSpecialDays, $iConfigIndex, $sDate, 0) ; und die Eingabedaten bei dem entsprechenden Listview-Eintrag aendern
		_GUICtrlListView_SetItemText($idSpecialDays, $iConfigIndex, $sName, 1)
		_GUICtrlListView_SetItemText($idSpecialDays, $iConfigIndex, $sSense, 2)
	EndIf
	GUICtrlSetState($idInputOk, $GUI_HIDE) ; den "Ok"-Button verstecken
	_ConfigListSort() ; das Listview sortieren
	_ConfigNewInput() ; und eine neue Eingabe vorbereiten
EndFunc   ;==>_ConfigInputOk

Func _ConfigListSort() ; Sortierung des Arrays $aSpecialDaysCopy und des Listviews (Konfigurationsfenster)
	Local $iCount = UBound($aSpecialDaysCopy) - 1 ; Anzahl der Eintraege im Array der besonderen Tage
	For $i = 0 To $iCount - 1
		For $j = $i + 1 To $iCount
			If $aSpecialDaysCopy[$i][2] > $aSpecialDaysCopy[$j][2] Then _ConfigListSortSwitch($aSpecialDaysCopy, $i, $j) ; Sortierung: Geburtstag, Hochzeitstag, Jahrestag
			If $aSpecialDaysCopy[$i][2] == $aSpecialDaysCopy[$j][2] Then ; wenn gleich, dann nach Datum (aeltester Eintrag oben)
				If $aSpecialDaysCopy[$i][0] > $aSpecialDaysCopy[$j][0] Then _ConfigListSortSwitch($aSpecialDaysCopy, $i, $j)
			EndIf
		Next
	Next
	_GUICtrlListView_BeginUpdate($idSpecialDays) ; das Listview fuer die Bearbeitung sperren
	_GUICtrlListView_DeleteAllItems($idSpecialDays) ; alle Eintraege aus dem Listview entfernen
	_GUICtrlListView_AddArray($idSpecialDays, $aSpecialDaysCopy) ; und das sortierte Array ins Listview eintragen
	For $i = 0 To 2
		_GUICtrlListView_SetColumnWidth($idSpecialDays, $i, $LVSCW_AUTOSIZE) ; die Spaltenbreite entsprechend dem Inhalt anpassen
	Next
	_GUICtrlListView_EndUpdate($idSpecialDays) ; das Listview wieder freigeben
EndFunc   ;==>_ConfigListSort

Func _ConfigListSortSwitch(ByRef $aData, $i, $j) ; Hilfsfunktion fuer _ConfigListSort() zum tauschen der Array-Eintraege ($i <-> $j)
	Local $sTmp
	For $iCol = 0 To 2
		$sTmp = $aData[$i][$iCol]
		$aData[$i][$iCol] = $aData[$j][$iCol]
		$aData[$j][$iCol] = $sTmp
	Next
EndFunc   ;==>_ConfigListSortSwitch

Func _CheckInputChange() ; zum testen, ob beim Bearbeiten eines Listview-Eintrags, eine Aenderung an den Daten vorgenommen wurde (Konfigurationsfenster)
	If $iConfigIndex = -1 Then Return ; wenn gar keine Bearbeitung vorliegt, dann Funktion verlassen ("-1" = neu erstellen)
	Local $bChange = False ; Variable auf "keine Aenderung"
	If StringRegExpReplace(GUICtrlRead($idInputDate), '(\d{2}).(\d{2}).(\d{4})', '$3/$2/$1') <> $aSpecialDaysCopy[$iConfigIndex][0] Then $bChange = True
	If GUICtrlRead($idInputName) <> $aSpecialDaysCopy[$iConfigIndex][1] Then $bChange = True
	If GUICtrlRead($idInputSense) <> $aSpecialDaysCopy[$iConfigIndex][2] Then $bChange = True
	GUICtrlSetState($idInputOk, $bChange ? $GUI_SHOW : $GUI_HIDE) ; wenn eine Aenderung der Daten vorliegt, dann den Button "Daten aendern" anzeigen
EndFunc   ;==>_CheckInputChange

Func _WM_COMMAND($hWnd, $iMsg, $wParam, $lParam) ; wird fuer die Aenderungen bei den Input-Controls (Konfigurationsfenster) gebraucht
	#forceref $hWnd, $iMsg
	Local $iIDFrom, $iCode, $sPLZ, $iFound
	$iIDFrom = _WinAPI_LoWord($wParam) ; welches Control-Element den Code gesendet hat
	$iCode = _WinAPI_HiWord($wParam) ; welcher Code gesendet wurde
	Switch $iIDFrom
		Case $idConfigPLZ
			Switch $iCode
				Case $EN_CHANGE ; wenn im PLZ-Eingabefeld eine Aenderung stattgefunden hat
					$sPLZ = GUICtrlRead($idConfigPLZ) ; die PLZ auslesen
					If StringLen($sPLZ) = 5 Then ; wenn die PLZ fuenfstellig ist, dann...
						$iFound = _ArraySearch($aPLZdata, $sPLZ, 0, 0, 0, 0, 1, 1) ; in der Datenbank (Geonames) danach suchen
						If $iFound > -1 Then ; wenn ein Eintrag gefunden wurde, dann...
							GUICtrlSetData($idConfigLat, $aPLZdata[$iFound][9]) ; Latitude aus der Datenbank in die GUI eintragen
							GUICtrlSetData($idConfigLon, $aPLZdata[$iFound][10]) ; Longitude aus der Datenbank in die GUI eintragen
							GUICtrlSetState($idConfigOSM, $GUI_ENABLE) ; und den OpenStreetMap-Aufruf ermoeglichen
						EndIf
					Else ; wenn kein Eintrag gefunden wurde, dann...
						GUICtrlSetData($idConfigLat, '') ; Latitude-Feld leeren
						GUICtrlSetData($idConfigLon, '') ; Longitude-Feld leeren
						GUICtrlSetState($idConfigOSM, $GUI_DISABLE) ; und den OpenStreetMap-Aufruf sperren
					EndIf
			EndSwitch
		Case $idInputSense
			Switch $iCode
				Case $CBN_SELCHANGE ; wenn eine Aenderung bei der Combobox vorgenommen wurde
					_CheckInputChange() ; testen, ob der ausgewaehlte Eintrag geaendert wurde
			EndSwitch
		Case $idInputName ; wenn eine Aenderung bei der Namenseingabe vorgenommen wurde
			Switch $iCode
				Case $EN_CHANGE
					_CheckInputChange() ; testen, ob der ausgewaehlte Eintrag geaendert wurde
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_COMMAND

Func _WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam) ; wird fuer den Doppelklick auf das Listview und das aendern beim Date-Control (Konfigurationsfenster) gebraucht
	#forceref $hWnd, $iMsg, $wParam
	Local $tNMHDR, $iIDFrom, $iCode, $tInfo
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam) ; $tagNMHDR-Struktur erstellen ($lParam enthaelt den Pointer auf die Struktur)
	$iIDFrom = DllStructGetData($tNMHDR, 'IDFrom') ; welches Control-Element den Code gesendet hat
	$iCode = DllStructGetData($tNMHDR, 'Code') ; welcher Code gesendet wurde
	Switch $iIDFrom
		Case $idInputDate
			Switch $iCode
				Case $DTN_DATETIMECHANGE ; wenn eine Aenderung beim Date-Control vorgenommen wurde
					_CheckInputChange() ; testen, ob der ausgewaehlte Eintrag geaendert wurde
			EndSwitch
		Case $idSpecialDays
			Switch $iCode
				Case $NM_DBLCLK ; wenn ein Doppelklick auf das Listview stattfand
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam) ; $tagNMITEMACTIVATE-Struktur erstellen
					$iConfigIndex = DllStructGetData($tInfo, 'Index') ; den Index des Eintrags auslesen ("-1" wenn ausserhalb)
					If $iConfigIndex > -1 Then ; wenn der Doppelklick auf einen Eintrag stattfand, dann...
						GUICtrlSetData($idInputDate, $aSpecialDaysCopy[$iConfigIndex][0]) ; die Daten aus dem Array in die Eingabefelder uebernehmen
						GUICtrlSetData($idInputName, $aSpecialDaysCopy[$iConfigIndex][1])
						GUICtrlSetData($idInputSense, $aSpecialDaysCopy[$iConfigIndex][2])
						GUICtrlSetData($idInputOk, 'Eintrag ändern') ; die Button-Beschriftung anpassen
						GUICtrlSetState($idInputOk, $GUI_HIDE) ; und den Button verstecken (wird nur bei einer Aenderung angezeigt)
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _GetPLZdata() ; zum einlesen der Geonames-Datenbank in ein 2D-Array
	Local $sDatabase, $aRow, $aCol
	$sDatabase = BinaryToString(_geonames(), $SB_UTF8) ; die Daten befinden sich BASE64-Codiert im Script
	$aRow = StringSplit($sDatabase, @LF, $STR_NOCOUNT) ; den String am Zeilenende aufsplitten
	Local $aData[UBound($aRow) - 1][12] ; ein entsprechend grosses 2D-Array erstellen
	For $i = 0 To UBound($aRow) - 2 ; alle "Zeilen" durchgehen
		$aCol = StringSplit($aRow[$i], @TAB, $STR_NOCOUNT) ; die Zeilen am @TAB aufsplitten
		For $j = 0 To 11 ; alle "Spalten" durchgehen
			$aData[$i][$j] = $aCol[$j] ; die Daten ins 2D-Array uebernehmen
		Next
	Next
	Return $aData ; das 2D-Array zurueckgeben
EndFunc   ;==>_GetPLZdata

Func _ReadSpecialDays() ; zum einlesen der "besonderen Tage" in das globale 2D-Array "$aSpecialDays"
	Local $sData, $aLines, $aColumn, $iCount = 0
	$sData = FileRead($sSpecialDaysFile) ; die Datei einlesen
	If @error Then Return ; wenn keine Datei vorhanden, dann abbrechen
	$sData = StringRegExpReplace($sData, '(\h*;.*?\v+)', '') ; alle Zeilen mit Kommentaren (beginnen mit ";") entfernen
	$aLines = StringSplit($sData, @CRLF, $STR_NOCOUNT + $STR_ENTIRESPLIT) ; den String am Zeilenende aufsplitten
	If @error Then Return ; wenn kein Eintrag in der Datei, dann abbrechen
	ReDim $aSpecialDays[UBound($aLines)][3] ; das 2D-Array $aSpecialDays (global vorhanden) anpassen
	For $i = 0 To UBound($aLines) - 1 ; alle "Zeilen" durchgehen
		If $aLines[$i] <> '' Then ; wenn die Zeile nicht leer ist, dann...
			$aColumn = StringSplit($aLines[$i], '|', $STR_NOCOUNT) ; die Zeilen am "|" aufsplitten
			If UBound($aColumn) = 3 Then ; wenn es drei Spalten sind
				For $j = 0 To 2 ; alle "Spalten" durchgehen
					$aSpecialDays[$iCount][$j] = $aColumn[$j] ; die Daten ins 2D-Array uebernehmen
				Next
				$iCount += 1 ; den Zaehler um eins erhoehen
			EndIf
		EndIf
	Next
	ReDim $aSpecialDays[$iCount][3] ; das 2D-Array $aSpecialDays (global vorhanden) anpassen
EndFunc   ;==>_ReadSpecialDays

Func _ChangeAutostart() ; zum aendern des Autostart-Eintrags (Traymenue-Eintrag nur im kompilierten Zustand aktiv)
	$bAutostart = Not $bAutostart ; Status umschalten
	Switch $bAutostart ; je nach Statuswert
		Case True
			FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName, @ScriptDir) ; einen Link im Autostart erstellen
			_GUICtrlMenu_SetItemBmp($hMenu, 2, $hCheckBMP) ; den Haken beim Traymenue-Eintrag setzen
		Case False
			FileDelete(@StartupDir & '\' & @ScriptName & '.lnk') ; den Link aus dem Autostart entfernen
			_GUICtrlMenu_SetItemBmp($hMenu, 2, $hNoCheckBMP) ; den Haken beim Traymenue-Eintrag entfernen
	EndSwitch
EndFunc   ;==>_ChangeAutostart

Func _CreateHBitmapFromImage($bImage, $iSize = 24) ; Funktion, um aus den binaeren Daten der PNGs HBITMAPs fuers Traymenue zu erstellen
	Local $hBitmap, $hResize, $hBMP
	$hBitmap = _GDIPlus_BitmapCreateFromMemory($bImage) ; die binaeren Daten als GDI+ Bitmap laden
	$hResize = _GDIPlus_ImageResize($hBitmap, $iSize, $iSize) ; entsprechend der Groesse skalieren (erstellt eine neue GDI+ Bitmap)
	$hBMP = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hResize) ; eine HBITMAP (GDI) aus der GDI+ Bitmap erstellen
	_GDIPlus_BitmapDispose($hResize) ; GDI+ Bitmap aus dem Speicher entfernen
	_GDIPlus_BitmapDispose($hBitmap) ; GDI+ Bitmap aus dem Speicher entfernen
	Return $hBMP ; und die HBITMAP zurueckgeben -> muss bei Programmende aus dem Speicher entfernt werden (_WinAPI_DeleteObject)
EndFunc   ;==>_CreateHBitmapFromImage

Func _PlayMP3FromMem($dSound, $iSleep = 0) ; Funktion, um eine MP3-Datei direkt aus dem Speicher abzuspielen (interner Alarmton)
	; Convert mp3 to a hybrid wav.
	Local $sAlign_Buffer = '00', _
			$sHeader_1 = '0x52494646', _
			$sHeader_2 = '57415645666D74201E0000005500020044AC0000581B0000010000000C00010002000000B600010071056661637404000000640E060064617461'
	Local $sMp3 = StringTrimLeft($dSound, 2), $iLength = BinaryLen($dSound)
	; Convert to required format.
	Local $iMp3Size = StringRegExpReplace(Hex($iLength, 8), '(..)(..)(..)(..)', '$4$3$2$1')
	Local $iWavSize = StringRegExpReplace(Hex($iLength + 63, 8), '(..)(..)(..)(..)', '$4$3$2$1')
	; Construct hybrid wav file.
	Local $sHybridWav = $sHeader_1 & $iWavSize & $sHeader_2 & $iMp3Size & $sMp3
	If Mod($iMp3Size, 2) Then $sHybridWav &= $sAlign_Buffer
	; Create struct.
	Local $tWAV = DllStructCreate('byte array[' & BinaryLen($sHybridWav) & ']')
	DllStructSetData($tWAV, 'array', $sHybridWav)
	Local $iFlags = BitOR($SND_MEMORY, $SND_ASYNC)
	_WinAPI_PlaySound(DllStructGetPtr($tWAV), $iFlags, 0)
	If $iSleep Then Sleep($iSleep)
EndFunc   ;==>_PlayMP3FromMem

;===============================================================================
; Function Name:   _WindowOnDesktop($hWnd)
; Description:     Prueft, ob sich das Fenster auf dem Desktop befindet und
;                  zentriert es auf diesen, wenn es nicht so ist
; Parameter(s):    $hWnd = das Handle des Fensters
; Requirement(s):  #include <WinAPI.au3>
; Return Value(s): True, wenn erfolgreich, ansonsten False und
;                  @error = 1, wenn $hWnd kein Handle ist
;                  @error = 2, wenn Fehler bei _WinAPI_GetWindowInfo()
; Author(s):       Oscar + Bitnugger (www.autoit.de)
;===============================================================================
Func _WindowOnDesktop($hWnd)
	Local $tDesktopInfo, $tDesktopRect, $tWindowPlacement, $tWindowPoint, $iWidth, $iHeight, $tRect, $iLeft, $iTop
	If Not IsHWnd($hWnd) Then Return SetError(1, 0, False)
	$tDesktopInfo = _WinAPI_GetWindowInfo(WinGetHandle('[CLASS:Progman]'))
	If @error Then Return SetError(2, 0, False)
	$tDesktopRect = DllStructCreate($tagRECT, DllStructGetPtr($tDesktopInfo, 'rWindow'))
	$tWindowPlacement = _WinAPI_GetWindowPlacement($hWnd)
	$tWindowPoint = DllStructCreate($tagPOINT, DllStructGetPtr($tWindowPlacement, 'rcNormalPosition'))
	If Not _WinAPI_PtInRect($tDesktopRect, $tWindowPoint) Then ; wenn das Fenster sich nicht auf dem Desktop befindet, dann...
		$iWidth = DllStructGetData($tWindowPlacement, 'rcNormalPosition', 3) - DllStructGetData($tWindowPlacement, 'rcNormalPosition', 1)
		$iHeight = DllStructGetData($tWindowPlacement, 'rcNormalPosition', 4) - DllStructGetData($tWindowPlacement, 'rcNormalPosition', 2)
		$tRect = _WinAPI_GetWorkArea() ; hole die Desktop-WorkArea (ohne Taskleiste)
		$iLeft = (DllStructGetData($tRect, 'Right') - DllStructGetData($tRect, 'Left')) / 2 - $iWidth / 2 ; Left neu berechnen
		$iTop = (DllStructGetData($tRect, 'Bottom') - DllStructGetData($tRect, 'Top')) / 2 - $iHeight / 2 ; Top neu berechnen
		DllStructSetData($tWindowPlacement, 'rcNormalPosition', $iLeft, 1) ; Setze das neue Left
		DllStructSetData($tWindowPlacement, 'rcNormalPosition', $iTop, 2) ; Setze das neue Top
		DllStructSetData($tWindowPlacement, 'rcNormalPosition', $iLeft + $iWidth, 3) ; Setze das neue Right
		DllStructSetData($tWindowPlacement, 'rcNormalPosition', $iTop + $iHeight, 4) ; Setze das neue Bottom
		_WinAPI_SetWindowPlacement($hWnd, $tWindowPlacement)
		Return SetError(0, 0, False)
	EndIf
	Return SetError(0, 0, True)
EndFunc   ;==>_WindowOnDesktop

Func _CreateAboutGui() ; das Programminformationsfenster erstellen
	Local Const $aGuiText[] = ['Programm:', 'Version:', 'Datum:', 'Autor:', 'EMail:', 'Homepage:']
	Local Const $aGuiContent[] = [$sAppTitle, $sAppVersion, $sAppDate, $sAppAuthor, $sAppAuthorEMail, $sAppURL]
	Local $sContent, $aSize, $iWidth = 530, $iHeight = 690
	$hAboutGui = GUICreate(StringFormat('Programm-Informationen  %s   v%3.3s', $sAppTitle, $sAppVersion), $iWidth, $iHeight, -1, -1, BitOR($WS_POPUP, $WS_CAPTION), $WS_EX_TOPMOST, $hMainGui)
	GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseAboutGui', $hAboutGui)
	GUISetBkColor(0xCCCCCC, $hAboutGui)

	GUICtrlCreateIcon($sAppIcon, -1, 22, 38, 48, 48)
	GUICtrlCreateGroup('Copyright', 10, 10, $iWidth - 20, 220) ; Gruppe: Copyright
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
	For $i = 0 To 5
		GUICtrlCreateLabel($aGuiText[$i], 90, 40 + $i * 30, 110, 24) ; die Copyright-Texte
		GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')
		GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
		$sContent = StringRegExpReplace($aGuiContent[$i], '(http://|https://|mailto:)(.+)', '$2')
		$aidContent[$i] = GUICtrlCreateLabel($sContent, 200, 37 + $i * 30, $iWidth - 220, 24) ; der Copyright-Inhalt
		GUICtrlSetTip(-1, ($i > 3 ? $aGuiContent[$i] : '')) ; Tooltip (bei den Links die URL, ansonsten nichts)
		GUICtrlSetFont(-1, 14 / $iAppDPI * 96, 600, ($i > 3 ? 4 : 0), 'Verdana') ; Font (bei den Links "unterstrichen" auswaehlen)
		GUICtrlSetColor(-1, ($i > 3 ? 0x0000CC : 0x000000)) ; Schriftfarbe (blau bei den Links, ansonsten schwarz)
		GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetCursor(-1, ($i > 3 ? 0 : -1)) ; Mauszeiger (Hand bei den Links, ansonsten Standard-Pfeil)
		GUICtrlSetOnEvent(-1, ($i > 3 ? '_AboutLinkCall' : ''))
		$aSize = _GetStringDimensions(GUICtrlGetHandle($aidContent[$i]), $sContent) ; die Stringlaenge messen
		GUICtrlSetPos($aidContent[$i], 200, 37 + $i * 30, $aSize[0], $aSize[1]) ; das Label entsprechend anpassen
	Next
	GUICtrlCreateGroup('', -99, -99, 1, 1)

	GUICtrlCreateGroup('Lizenzbedingungen', 10, 240, $iWidth - 20, 150)
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
	GUICtrlCreateLabel(StringFormat($sLicence), 30, 270, $iWidth - 50, 75) ; Lizenz-Text
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

	$idLicence = GUICtrlCreateLabel($sLicenceURL, 30, 350, $iWidth - 50, 25) ; Lizenz-Link
	GUICtrlSetOnEvent(-1, '_AboutLinkCall')
	GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 4, 'Verdana')
	GUICtrlSetColor(-1, 0x0000CC)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlCreateGroup('', -99, -99, 1, 1)

	GUICtrlCreateGroup('Danksagungen', 10, 400, $iWidth - 20, 185)
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 2, 'Verdana')
	GUICtrlCreateLabel(StringFormat($sThanks), 30, 430, $iWidth - 50, 170) ; Danksagungen
	GUICtrlSetFont(-1, 11 / $iAppDPI * 96, 400, 0, 'Verdana')
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlCreateGroup('', -99, -99, 1, 1)

	$idNewVersion = GUICtrlCreateLabel('', 30, $iHeight - 100, 180, 20) ; zur Anzeige der Server-Version
	GUICtrlSetFont(-1, 12 / $iAppDPI * 96, 400, 0, 'Verdana')

	$idDLcheck = GUICtrlCreateButton('', 10, $iHeight - 76, 180, 34) ; "Neue Version"-Button (nur im kompilierten Zustand aktiv)
	GUICtrlSetOnEvent(-1, '_CheckNewVersion')
	_GuiCtrlSetImageEx(-1, $dQuestion, 'Neue Version?', $GCSIE_RIGHT, 12, 0, 'Verdana')

	GUICtrlCreateButton('', 210, $iHeight - 76, 160, 34) ; "Schliessen"-Button
	GUICtrlSetOnEvent(-1, '_CloseAboutGui')
	_GuiCtrlSetImageEx(-1, $dClose, 'Schließen', $GCSIE_RIGHT, 12, 0, 'Verdana')

	$idDLprogress = GUICtrlCreateProgress(10, $iHeight - 30, $iWidth - 20, 20) ; Download-Progressbar
EndFunc   ;==>_CreateAboutGui

Func _GetStringDimensions($hWnd, $sText) ; zum ermitteln der Stringlaenge fuer ein Label
	Local $hDC = _WinAPI_GetDC($hWnd) ; Get the device context handle of the current window.
	Local $hFont = _SendMessage($hWnd, $WM_GETFONT) ; Retrieve the font with which the control is currently drawing its text.
	Local $hSelectObject = _WinAPI_SelectObject($hDC, $hFont) ; Select the object of the context device.
	Local $tSIZE = _WinAPI_GetTextExtentPoint32($hDC, $sText) ; Retrieve the height & width of a string.
	_WinAPI_SelectObject($hDC, $hSelectObject)
	_WinAPI_ReleaseDC($hWnd, $hDC) ; Release the device context.
	Local $aReturn[2] = [DllStructGetData($tSIZE, 1), DllStructGetData($tSIZE, 2)] ; Set an array with the width & height of the string.
	Return $aReturn
EndFunc   ;==>_GetStringDimensions

Func _OpenAboutGui() ; das Programminformationsfenster oeffnen
	Local $hMonitor, $aData, $aMainPos, $aAboutPos, $iLeft, $iTop
	$hMonitor = _WinAPI_MonitorFromWindow($hMainGui) ; feststellen, auf welchem Monitor das Hauptfenster angezeigt wird
	$aData = _WinAPI_GetMonitorInfo($hMonitor) ; die Daten dieses Monitors holen ($aData[0] = $tagRECT)
	Local $aPos[4] = [DllStructGetData($aData[0], 1), DllStructGetData($aData[0], 2), DllStructGetData($aData[0], 3), DllStructGetData($aData[0], 4)]
	$aMainPos = WinGetPos($hMainGui) ; die Positionsdaten des Hauptfensters holen
	$aAboutPos = WinGetPos($hAboutGui) ; die Abmessungen des Programminformationsfenster holen
	$iLeft = $aMainPos[0] + ($aMainPos[2] / 2) - ($aAboutPos[2] / 2) ; den linken Rand fuer das Programminformationsfenster berechnen
	If $iLeft < $aPos[0] + 16 Then $iLeft = $aPos[0] + 16 ; wenn der linke Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	If $iLeft > $aPos[2] - $aAboutPos[2] - 16 Then $iLeft = $aPos[2] - $aAboutPos[2] - 16 ; wenn der rechte Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	$iTop = $aMainPos[1] + ($aMainPos[3] / 2) - ($aAboutPos[3] / 2) ; den oberen Rand fuer das Programminformationsfenster berechnen
	If $iTop < $aPos[1] + 16 Then $iTop = $aPos[1] + 16 ; wenn der obere Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	If $iTop > $aPos[3] - $aAboutPos[3] - 16 Then $iTop = $aPos[3] - $aAboutPos[3] - 16 ; wenn der untere Rand ausserhalb des Monitors liegen wuerde, dann in den sichtbaren Bereich verschieben
	WinMove($hAboutGui, '', $iLeft, $iTop) ; das Programminformationsfenster an diese Position verschieben
	_GuiCtrlSetImageEx($idDLcheck, $dQuestion, 'Neue Version?', $GCSIE_RIGHT, 12, 0, 'Verdana')
	GUICtrlSetState($idDLcheck, $GUI_ENABLE)
	GUICtrlSendMsg($idDLprogress, $PBM_SETSTATE, 0x0001, 0) ; Progressbar-Status: Normal (gruen)
	GUICtrlSetData($idDLprogress, 0) ; Progressbar auf Null setzen
	$iUpdate = 0 ; Update-Status auf Null setzen (erster Schritt = Test auf neue Version)
	If Not @Compiled Then GUICtrlSetState($idDLcheck, $GUI_DISABLE) ; im nicht kompilierten Zustand den Update-Check-Button deaktivieren
	TraySetState($TRAY_ICONSTATE_HIDE) ; das Tray-Icon verstecken
	GUISetState(@SW_DISABLE, $hMainGui) ; das Hauptfenster deaktivieren
	GUISetState(@SW_SHOW, $hAboutGui) ; das Programminformationsfenster anzeigen
EndFunc   ;==>_OpenAboutGui

Func _CloseAboutGui() ; das Programminformationsfenster schliessen
	TraySetState($TRAY_ICONSTATE_SHOW) ; das Tray-Icon wieder anzeigen
	GUISetState(@SW_ENABLE, $hMainGui) ; das Hauptfenster wieder aktivieren
	GUISetState(@SW_HIDE, $hAboutGui) ; das Programminformationsfenster verstecken
EndFunc   ;==>_CloseAboutGui

Func _AboutLinkCall() ; hier werden die anklickbaren Laben (Links) aufgerufen
	Switch @GUI_CtrlId ; je nachdem welches Label angeklickt wurde, wird die dazugehoerige URL (siehe Konstanten) aufgerufen
		Case $idLicence
			ShellExecute($sLicenceURL)
		Case $aidContent[4]
			ShellExecute($sAppAuthorEMail)
		Case $aidContent[5]
			ShellExecute($sAppURL)
	EndSwitch
EndFunc   ;==>_AboutLinkCall

Func _CheckNewVersion() ; Funktion zum updaten des Programms
	Switch $iUpdate ; je nachdem, welchen Wert die Variable hat
		Case 0 ; Testen, ob eine neue Version auf dem Server liegt
			Local $sVersion = _NewVersion($sAppVersion, $sAppVersionURL)
			If @extended Then ; wenn eine neue Version auf dem Server liegt, dann...
				GUICtrlSetData($idNewVersion, 'Server: v' & $sVersion) ; die Server-Version anzeigen
				_GuiCtrlSetImageEx($idDLcheck, $dQuestion, 'Updaten?', $GCSIE_RIGHT, 12, 0, 'Verdana') ; den Button-Text aendern
				$iUpdate = 1 ; und den Status auf das updaten setzen
			Else ; ansonsten (keine neue Version auf dem Server vorhanden)
				_GuiCtrlSetImageEx($idDLcheck, $dInfo, 'Version aktuell', $GCSIE_RIGHT, 12, 0, 'Verdana') ; den Button-Text aendern
				GUICtrlSetState($idDLcheck, $GUI_DISABLE) ; den Button deaktivieren
				$iUpdate = -1 ; und den Status auf deaktiviert setzen (wird beim naechsten Aufruf des Programminformationsfensters wieder auf 0 gesetzt)
			EndIf
		Case 1 ; hier wird die eigentliche Updatefunktion aufgerufen (Download, Exe austauschen und Programmneustart)
			_SelfUpdate($sAppUpdateURL)
	EndSwitch
EndFunc   ;==>_CheckNewVersion

Func _NewVersion($sOldVersion, $sURL) ; zum testen, ob auf dem Server eine neue Version liegt (URL in $sAppVersionURL bei den Konstanten)
	Local $sNewVersion, $dVersion, $iRet
	$dVersion = InetRead($sURL, $INET_FORCERELOAD) ; hier wird nur eine Textdatei mit der Versionsnummer heruntergeladen
	If $dVersion = '' Then Return SetError(2, False, $sOldVersion) ; wenn das fehlgeschlagen ist, dann Funktion verlassen
	$sNewVersion = BinaryToString($dVersion, 4) ; Binaerwert in UTF8 umwandeln
	$iRet = _VersionCompare($sNewVersion, $sOldVersion) ; vergleichen, ob die Server-Version neuer als die Programmversion ist
	If $iRet < 1 Then Return SetError(3, False, $sOldVersion) ; wenn nein, dann die alte Versionnummer zurueckgeben
	Return SetError(0, True, $sNewVersion) ; wenn ja, dann die neue Versionsnummer zurueckgeben
EndFunc   ;==>_NewVersion

Func _SelfUpdate($sUpdateURL) ; Updatefunktion (Download, Exe austauschen und Programmneustart)
	Local $iDlSize, $hDownload, $iDlRead, $iPercent, $sScriptName, $iPID, $hFile
	Local $sBatchUpdate = @ScriptDir & '\Digitaluhr_v4_update.bat', $iTimer = TimerInit()
	FileChangeDir(@ScriptDir) ; das WorkingDir aendern
	$iDlSize = InetGetSize($sUpdateURL, $INET_FORCERELOAD) ; die Dateigroesse holen
	$hDownload = InetGet($sUpdateURL, 'du_v4_up.exe', $INET_FORCERELOAD, $INET_DOWNLOADBACKGROUND) ; Datei im Hintergrund herunterladen
	While Not InetGetInfo($hDownload, $INET_DOWNLOADCOMPLETE) ; Schleife ausfuehren, solange wie der Download andauert
		$iDlRead = InetGetInfo($hDownload, $INET_DOWNLOADREAD) ; bisher uebertragene Bytes
		$iPercent = Int(100 / $iDlSize * $iDlRead) ; Prozent ausrechnen
		GUICtrlSetData($idDLprogress, $iPercent) ; Progressbar fuellen
		Sleep(10) ; ein kurzes Sleep, um den Prozessor zu entlasten
		If TimerDiff($iTimer) > 60000 Then ; wenn der Download laenger als 60 sek. dauert, Fehlermeldung
			GUICtrlSetData($idDLprogress, 100) ; Progressbar auf 100 setzen
			GUICtrlSendMsg($idDLprogress, $PBM_SETSTATE, 0x0002, 0) ; Progressbar-Status: Error (rot)
			_GuiCtrlSetImageEx($idDLcheck, $dInfo, 'Zeitfehler!', $GCSIE_RIGHT, 12, 0, 'Verdana')
			GUICtrlSetState($idDLcheck, $GUI_DISABLE) ; Button deaktivieren
			InetClose($hDownload) ; Download-Handle schliessen
			Return SetError(1, 0, 0)
		EndIf
	WEnd
	GUICtrlSetData($idDLprogress, 100) ; Progressbar auf 100 setzen
	Sleep(500) ; kurz warten, damit der Benutzer das registriert hat
	If InetGetInfo($hDownload, $INET_DOWNLOADERROR) <> 0 Then ; wenn beim Download ein Fehler aufgetreten ist, dann...
		GUICtrlSendMsg($idDLprogress, $PBM_SETSTATE, 0x0002, 0) ; Progressbar-Status: Error (rot)
		_GuiCtrlSetImageEx($idDLcheck, $dInfo, 'Downloadfehler!', $GCSIE_RIGHT, 12, 0, 'Verdana')
		GUICtrlSetState($idDLcheck, $GUI_DISABLE) ; Button deaktivieren
		InetClose($hDownload) ; Download-Handle schliessen
		Return SetError(2, 0, 0)
	Else
		InetClose($hDownload) ; Download-Handle schliessen
		$sScriptName = @ScriptName
		$iPID = @AutoItPID
		$hFile = FileOpen($sBatchUpdate, $FO_OVERWRITE) ; Batchdatei zum ueberschreiben oeffnen
		If $hFile = -1 Then Return SetError(2, 0, 0) ; wenn die Batchdatei nicht geoeffnet werden konnte, Funktion abbrechen
		; die Batchbefehle in die Datei schreiben
		FileWriteLine($hFile, "@echo off")
		FileWriteLine($hFile, ":loop")
		FileWriteLine($hFile, "tasklist /fi " & '"pid eq ' & $iPID & '" | find ":" > nul')
		FileWriteLine($hFile, "if errorlevel 1 (")
		FileWriteLine($hFile, "  ping 127.0.0.1 -n 2")
		FileWriteLine($hFile, "  goto loop")
		FileWriteLine($hFile, ") else (")
		FileWriteLine($hFile, "  goto continue")
		FileWriteLine($hFile, ")")
		FileWriteLine($hFile, ":continue")
		FileWriteLine($hFile, "del " & '"' & $sScriptName & '"')
		FileWriteLine($hFile, "ren du_v4_up.exe " & '"' & $sScriptName & '"')
		FileWriteLine($hFile, 'start "" ' & '"' & $sScriptName & '"')
		FileWriteLine($hFile, "start /b """" cmd /c del ""%~f0""&exit /b")
		FileClose($hFile) ; die Batchdatei schliessen
		Run($sBatchUpdate, @ScriptDir, @SW_HIDE) ; und versteckt ausfuehren
		Exit ; das Programm beenden
	EndIf
EndFunc   ;==>_SelfUpdate
#EndRegion *** Funktionen ***
